# ClassifierApi

All URIs are relative to *https://platform.its4land.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**getClassifier**](ClassifierApi.md#getClassifier) | **GET** /classifier | Returns a list of classifier
[**getClassifierByUID**](ClassifierApi.md#getClassifierByUID) | **GET** /classifier/{classifier_id} | Returns a single classifier.
[**newClassifier**](ClassifierApi.md#newClassifier) | **POST** /classifier | Create a new classifier


<a name="getClassifier"></a>
# **getClassifier**
> List&lt;ClassifierEndpointType&gt; getClassifier(envelope, uid, name, models, tags, page, sort, fields)

Returns a list of classifier

Returns a list of classifier

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.ClassifierApi;


ClassifierApi apiInstance = new ClassifierApi();
String envelope = "envelope_example"; // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
List<String> uid = Arrays.asList("uid_example"); // List<String> | Comma separated list of classifier UID
List<String> name = Arrays.asList("name_example"); // List<String> | Comma separated list of classifier names
List<String> models = Arrays.asList("models_example"); // List<String> | Comma separated list of model UID
List<String> tags = Arrays.asList("tags_example"); // List<String> | Comma separated list of tags
Integer page = 56; // Integer | Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default.
String sort = "sort_example"; // String | The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by.
List<String> fields = Arrays.asList("fields_example"); // List<String> | Comma separated list of field names
try {
    List<ClassifierEndpointType> result = apiInstance.getClassifier(envelope, uid, name, models, tags, page, sort, fields);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ClassifierApi#getClassifier");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] [enum: yes, no]
 **uid** | [**List&lt;String&gt;**](String.md)| Comma separated list of classifier UID | [optional]
 **name** | [**List&lt;String&gt;**](String.md)| Comma separated list of classifier names | [optional]
 **models** | [**List&lt;String&gt;**](String.md)| Comma separated list of model UID | [optional]
 **tags** | [**List&lt;String&gt;**](String.md)| Comma separated list of tags | [optional]
 **page** | **Integer**| Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. | [optional]
 **sort** | **String**| The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. | [optional]
 **fields** | [**List&lt;String&gt;**](String.md)| Comma separated list of field names | [optional]

### Return type

[**List&lt;ClassifierEndpointType&gt;**](ClassifierEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="getClassifierByUID"></a>
# **getClassifierByUID**
> ClassifierEndpointType getClassifierByUID(classifierId, envelope)

Returns a single classifier.

Returns a single classifier.

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.ClassifierApi;


ClassifierApi apiInstance = new ClassifierApi();
String classifierId = "classifierId_example"; // String | Classifier UID
String envelope = "envelope_example"; // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
try {
    ClassifierEndpointType result = apiInstance.getClassifierByUID(classifierId, envelope);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ClassifierApi#getClassifierByUID");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **classifierId** | **String**| Classifier UID |
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] [enum: yes, no]

### Return type

[**ClassifierEndpointType**](ClassifierEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="newClassifier"></a>
# **newClassifier**
> ClassifierEndpointType newClassifier(newclassifier, envelope, i4lProcessUid)

Create a new classifier

Create a new classifier. To add a new Classifier , the content of Classifier must be stored in advanced via the ContentItem endpoint

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.ClassifierApi;


ClassifierApi apiInstance = new ClassifierApi();
ClassifierPostRequest newclassifier = new ClassifierPostRequest(); // ClassifierPostRequest | New Classifier data
String envelope = "envelope_example"; // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
String i4lProcessUid = "i4lProcessUid_example"; // String | Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
try {
    ClassifierEndpointType result = apiInstance.newClassifier(newclassifier, envelope, i4lProcessUid);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ClassifierApi#newClassifier");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **newclassifier** | [**ClassifierPostRequest**](ClassifierPostRequest.md)| New Classifier data |
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] [enum: yes, no]
 **i4lProcessUid** | **String**| Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. | [optional]

### Return type

[**ClassifierEndpointType**](ClassifierEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

