# MiscApi

All URIs are relative to *https://platform.its4land.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**getDDILayers**](MiscApi.md#getDDILayers) | **GET** /DDILayers | Return a list of registered DDI (WFS/WMS) Layer
[**getPuSConfig**](MiscApi.md#getPuSConfig) | **GET** /PuSConfig | Returns a list of configuration parameters as Key Value
[**newDDILayers**](MiscApi.md#newDDILayers) | **POST** /DDILayers | Register a new DDI (WFS/WMS) Layer


<a name="getDDILayers"></a>
# **getDDILayers**
> List&lt;DDILayersEndpointType&gt; getDDILayers(envelope, uid, name, type, projects, tags, page, sort, fields, embed)

Return a list of registered DDI (WFS/WMS) Layer

Return a list of registered DDI (WFS/WMS) Layer

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.MiscApi;


MiscApi apiInstance = new MiscApi();
String envelope = "envelope_example"; // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
List<String> uid = Arrays.asList("uid_example"); // List<String> | Comma separated list of TrainingSet UID
List<String> name = Arrays.asList("name_example"); // List<String> | Comma separated list of WP5ValidationSets Names
List<String> type = Arrays.asList("type_example"); // List<String> | Comma separated list OGC types
List<String> projects = Arrays.asList("projects_example"); // List<String> | Comma separated list of project UID
List<String> tags = Arrays.asList("tags_example"); // List<String> | Comma separated list of tags
Integer page = 56; // Integer | Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default.
String sort = "sort_example"; // String | The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by.
List<String> fields = Arrays.asList("fields_example"); // List<String> | Comma separated list of field names
List<String> embed = Arrays.asList("embed_example"); // List<String> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
try {
    List<DDILayersEndpointType> result = apiInstance.getDDILayers(envelope, uid, name, type, projects, tags, page, sort, fields, embed);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling MiscApi#getDDILayers");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] [enum: yes, no]
 **uid** | [**List&lt;String&gt;**](String.md)| Comma separated list of TrainingSet UID | [optional]
 **name** | [**List&lt;String&gt;**](String.md)| Comma separated list of WP5ValidationSets Names | [optional]
 **type** | [**List&lt;String&gt;**](String.md)| Comma separated list OGC types | [optional]
 **projects** | [**List&lt;String&gt;**](String.md)| Comma separated list of project UID | [optional]
 **tags** | [**List&lt;String&gt;**](String.md)| Comma separated list of tags | [optional]
 **page** | **Integer**| Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. | [optional]
 **sort** | **String**| The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. | [optional]
 **fields** | [**List&lt;String&gt;**](String.md)| Comma separated list of field names | [optional]
 **embed** | [**List&lt;String&gt;**](String.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional]

### Return type

[**List&lt;DDILayersEndpointType&gt;**](DDILayersEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="getPuSConfig"></a>
# **getPuSConfig**
> List&lt;PublishAndShareConfigEndpointType&gt; getPuSConfig(envelope, page, sort, fields, embed)

Returns a list of configuration parameters as Key Value

Returns a list of configuration parameters as Key Value. E.g. URL of the DDI server

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.MiscApi;


MiscApi apiInstance = new MiscApi();
String envelope = "envelope_example"; // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
Integer page = 56; // Integer | Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default.
String sort = "sort_example"; // String | The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by.
List<String> fields = Arrays.asList("fields_example"); // List<String> | Comma separated list of field names
List<String> embed = Arrays.asList("embed_example"); // List<String> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
try {
    List<PublishAndShareConfigEndpointType> result = apiInstance.getPuSConfig(envelope, page, sort, fields, embed);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling MiscApi#getPuSConfig");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] [enum: yes, no]
 **page** | **Integer**| Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. | [optional]
 **sort** | **String**| The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. | [optional]
 **fields** | [**List&lt;String&gt;**](String.md)| Comma separated list of field names | [optional]
 **embed** | [**List&lt;String&gt;**](String.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional]

### Return type

[**List&lt;PublishAndShareConfigEndpointType&gt;**](PublishAndShareConfigEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="newDDILayers"></a>
# **newDDILayers**
> DDILayersEndpointType newDDILayers(newDDILayer, envelope, embed, i4lProcessUid)

Register a new DDI (WFS/WMS) Layer

Register DDI (WFS/WMS) Layer

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.MiscApi;


MiscApi apiInstance = new MiscApi();
DDILayersPostRequest newDDILayer = new DDILayersPostRequest(); // DDILayersPostRequest | New image metadata
String envelope = "envelope_example"; // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
List<String> embed = Arrays.asList("embed_example"); // List<String> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
String i4lProcessUid = "i4lProcessUid_example"; // String | Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
try {
    DDILayersEndpointType result = apiInstance.newDDILayers(newDDILayer, envelope, embed, i4lProcessUid);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling MiscApi#newDDILayers");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **newDDILayer** | [**DDILayersPostRequest**](DDILayersPostRequest.md)| New image metadata |
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] [enum: yes, no]
 **embed** | [**List&lt;String&gt;**](String.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional]
 **i4lProcessUid** | **String**| Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. | [optional]

### Return type

[**DDILayersEndpointType**](DDILayersEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

