# ModelClassesApi

All URIs are relative to *https://platform.its4land.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**getModelClasses**](ModelClassesApi.md#getModelClasses) | **GET** /modelclasses | Returns ModelClasses
[**getModelClassesByUID**](ModelClassesApi.md#getModelClassesByUID) | **GET** /modelclasses/{modelclasses_uid} | Returns a single model class
[**updateModelClasses**](ModelClassesApi.md#updateModelClasses) | **PATCH** /modelclasses/{modelclasses_uid} | Updates some attributes of a ModelClass


<a name="getModelClasses"></a>
# **getModelClasses**
> List&lt;ModelClassesEndpointType&gt; getModelClasses(envelope, UID, nameinmodel, conceptname, page, sort, fields)

Returns ModelClasses

Returns ModelClasses

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.ModelClassesApi;


ModelClassesApi apiInstance = new ModelClassesApi();
String envelope = "envelope_example"; // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
List<String> UID = Arrays.asList("UID_example"); // List<String> | Comma separated list of ModelClasses UID
List<String> nameinmodel = Arrays.asList("nameinmodel_example"); // List<String> | Comma separated list of ModelClasses names
List<String> conceptname = Arrays.asList("conceptname_example"); // List<String> | Comma separated list of ModelClasses concept names
Integer page = 56; // Integer | Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default.
String sort = "sort_example"; // String | The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by.
List<String> fields = Arrays.asList("fields_example"); // List<String> | Comma separated list of field names
try {
    List<ModelClassesEndpointType> result = apiInstance.getModelClasses(envelope, UID, nameinmodel, conceptname, page, sort, fields);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ModelClassesApi#getModelClasses");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] [enum: yes, no]
 **UID** | [**List&lt;String&gt;**](String.md)| Comma separated list of ModelClasses UID | [optional]
 **nameinmodel** | [**List&lt;String&gt;**](String.md)| Comma separated list of ModelClasses names | [optional]
 **conceptname** | [**List&lt;String&gt;**](String.md)| Comma separated list of ModelClasses concept names | [optional]
 **page** | **Integer**| Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. | [optional]
 **sort** | **String**| The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. | [optional]
 **fields** | [**List&lt;String&gt;**](String.md)| Comma separated list of field names | [optional]

### Return type

[**List&lt;ModelClassesEndpointType&gt;**](ModelClassesEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="getModelClassesByUID"></a>
# **getModelClassesByUID**
> ModelClassesEndpointType getModelClassesByUID(modelclassesUid, envelope)

Returns a single model class

Returns a single model class

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.ModelClassesApi;


ModelClassesApi apiInstance = new ModelClassesApi();
String modelclassesUid = "modelclassesUid_example"; // String | ModelClass UID
String envelope = "envelope_example"; // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
try {
    ModelClassesEndpointType result = apiInstance.getModelClassesByUID(modelclassesUid, envelope);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ModelClassesApi#getModelClassesByUID");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **modelclassesUid** | **String**| ModelClass UID |
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] [enum: yes, no]

### Return type

[**ModelClassesEndpointType**](ModelClassesEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="updateModelClasses"></a>
# **updateModelClasses**
> ModelClassesEndpointType updateModelClasses(modelclassesUid, patchmodelclasses, envelope, i4lProcessUid)

Updates some attributes of a ModelClass

Updates some attributes of a ModelClass

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.ModelClassesApi;


ModelClassesApi apiInstance = new ModelClassesApi();
String modelclassesUid = "modelclassesUid_example"; // String | ModelClass UID
RFC6902PatchRequest patchmodelclasses = new RFC6902PatchRequest(); // RFC6902PatchRequest | Update data
String envelope = "envelope_example"; // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
String i4lProcessUid = "i4lProcessUid_example"; // String | Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
try {
    ModelClassesEndpointType result = apiInstance.updateModelClasses(modelclassesUid, patchmodelclasses, envelope, i4lProcessUid);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ModelClassesApi#updateModelClasses");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **modelclassesUid** | **String**| ModelClass UID |
 **patchmodelclasses** | [**RFC6902PatchRequest**](RFC6902PatchRequest.md)| Update data |
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] [enum: yes, no]
 **i4lProcessUid** | **String**| Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. | [optional]

### Return type

[**ModelClassesEndpointType**](ModelClassesEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

