# ModelsApi

All URIs are relative to *https://platform.its4land.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**getModels**](ModelsApi.md#getModels) | **GET** /models | Returns a list of models.
[**getModelsByUID**](ModelsApi.md#getModelsByUID) | **GET** /models/{model_uid} | Returns a single model
[**getModelsClassesByModel**](ModelsApi.md#getModelsClassesByModel) | **GET** /models/{model_uid}/modelclasses | Returns the model classes of the classifier.
[**newModel**](ModelsApi.md#newModel) | **POST** /models | Create a new model
[**newModelClassUnderModel**](ModelsApi.md#newModelClassUnderModel) | **POST** /models/{model_uid}/modelclasses | Create a new ModelClass under a model
[**updateModels**](ModelsApi.md#updateModels) | **PATCH** /models/{model_uid} | Updates some attributes of a model


<a name="getModels"></a>
# **getModels**
> List&lt;ModelsEndpointType&gt; getModels(envelope, uid, name, tools, projects, tags, page, sort, fields, embed)

Returns a list of models.

Returns a list of models.

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.ModelsApi;


ModelsApi apiInstance = new ModelsApi();
String envelope = "envelope_example"; // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
List<String> uid = Arrays.asList("uid_example"); // List<String> | Comma separated list of model UID
List<String> name = Arrays.asList("name_example"); // List<String> | Comma separated list of model names
List<String> tools = Arrays.asList("tools_example"); // List<String> | Comma separated list tool names which can make use of the model.
List<String> projects = Arrays.asList("projects_example"); // List<String> | Comma separated list of project UID
List<String> tags = Arrays.asList("tags_example"); // List<String> | Comma separated list of tags
Integer page = 56; // Integer | Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default.
String sort = "sort_example"; // String | The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by.
List<String> fields = Arrays.asList("fields_example"); // List<String> | Comma separated list of field names
List<String> embed = Arrays.asList("embed_example"); // List<String> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
try {
    List<ModelsEndpointType> result = apiInstance.getModels(envelope, uid, name, tools, projects, tags, page, sort, fields, embed);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ModelsApi#getModels");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] [enum: yes, no]
 **uid** | [**List&lt;String&gt;**](String.md)| Comma separated list of model UID | [optional]
 **name** | [**List&lt;String&gt;**](String.md)| Comma separated list of model names | [optional]
 **tools** | [**List&lt;String&gt;**](String.md)| Comma separated list tool names which can make use of the model. | [optional]
 **projects** | [**List&lt;String&gt;**](String.md)| Comma separated list of project UID | [optional]
 **tags** | [**List&lt;String&gt;**](String.md)| Comma separated list of tags | [optional]
 **page** | **Integer**| Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. | [optional]
 **sort** | **String**| The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. | [optional]
 **fields** | [**List&lt;String&gt;**](String.md)| Comma separated list of field names | [optional]
 **embed** | [**List&lt;String&gt;**](String.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional]

### Return type

[**List&lt;ModelsEndpointType&gt;**](ModelsEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="getModelsByUID"></a>
# **getModelsByUID**
> ModelsEndpointType getModelsByUID(modelUid, envelope, embed)

Returns a single model

Returns a single model

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.ModelsApi;


ModelsApi apiInstance = new ModelsApi();
String modelUid = "modelUid_example"; // String | Model  UID
String envelope = "envelope_example"; // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
List<String> embed = Arrays.asList("embed_example"); // List<String> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
try {
    ModelsEndpointType result = apiInstance.getModelsByUID(modelUid, envelope, embed);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ModelsApi#getModelsByUID");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **modelUid** | **String**| Model  UID |
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] [enum: yes, no]
 **embed** | [**List&lt;String&gt;**](String.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional]

### Return type

[**ModelsEndpointType**](ModelsEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="getModelsClassesByModel"></a>
# **getModelsClassesByModel**
> List&lt;ModelClassesEndpointType&gt; getModelsClassesByModel(modelUid, envelope, embed)

Returns the model classes of the classifier.

Returns the model classes of the classifier.

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.ModelsApi;


ModelsApi apiInstance = new ModelsApi();
String modelUid = "modelUid_example"; // String | Model  UID
String envelope = "envelope_example"; // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
List<String> embed = Arrays.asList("embed_example"); // List<String> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
try {
    List<ModelClassesEndpointType> result = apiInstance.getModelsClassesByModel(modelUid, envelope, embed);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ModelsApi#getModelsClassesByModel");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **modelUid** | **String**| Model  UID |
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] [enum: yes, no]
 **embed** | [**List&lt;String&gt;**](String.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional]

### Return type

[**List&lt;ModelClassesEndpointType&gt;**](ModelClassesEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="newModel"></a>
# **newModel**
> ModelsEndpointType newModel(newmodel, envelope, embed, i4lProcessUid)

Create a new model

Create a new model. The model can be assigned to a project via the patch://project method. To add a new SpatialSources , the content of Models  must be stored in advanced via the ContentItem endpoint

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.ModelsApi;


ModelsApi apiInstance = new ModelsApi();
ModelsPostRequest newmodel = new ModelsPostRequest(); // ModelsPostRequest | New Model data
String envelope = "envelope_example"; // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
List<String> embed = Arrays.asList("embed_example"); // List<String> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
String i4lProcessUid = "i4lProcessUid_example"; // String | Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
try {
    ModelsEndpointType result = apiInstance.newModel(newmodel, envelope, embed, i4lProcessUid);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ModelsApi#newModel");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **newmodel** | [**ModelsPostRequest**](ModelsPostRequest.md)| New Model data |
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] [enum: yes, no]
 **embed** | [**List&lt;String&gt;**](String.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional]
 **i4lProcessUid** | **String**| Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. | [optional]

### Return type

[**ModelsEndpointType**](ModelsEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="newModelClassUnderModel"></a>
# **newModelClassUnderModel**
> ModelClassesEndpointType newModelClassUnderModel(modelUid, newmodelclass, envelope, embed, i4lProcessUid)

Create a new ModelClass under a model

Create a new ModelClass under a model

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.ModelsApi;


ModelsApi apiInstance = new ModelsApi();
String modelUid = "modelUid_example"; // String | Model  UID
ModelClassesPostRequest newmodelclass = new ModelClassesPostRequest(); // ModelClassesPostRequest | New ModelClass data
String envelope = "envelope_example"; // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
List<String> embed = Arrays.asList("embed_example"); // List<String> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
String i4lProcessUid = "i4lProcessUid_example"; // String | Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
try {
    ModelClassesEndpointType result = apiInstance.newModelClassUnderModel(modelUid, newmodelclass, envelope, embed, i4lProcessUid);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ModelsApi#newModelClassUnderModel");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **modelUid** | **String**| Model  UID |
 **newmodelclass** | [**ModelClassesPostRequest**](ModelClassesPostRequest.md)| New ModelClass data |
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] [enum: yes, no]
 **embed** | [**List&lt;String&gt;**](String.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional]
 **i4lProcessUid** | **String**| Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. | [optional]

### Return type

[**ModelClassesEndpointType**](ModelClassesEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="updateModels"></a>
# **updateModels**
> ModelsEndpointType updateModels(modelUid, patchmodel, envelope, embed, i4lProcessUid)

Updates some attributes of a model

Updates some attributes of a model

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.ModelsApi;


ModelsApi apiInstance = new ModelsApi();
String modelUid = "modelUid_example"; // String | Model  UID
RFC6902PatchRequest patchmodel = new RFC6902PatchRequest(); // RFC6902PatchRequest | Update data
String envelope = "envelope_example"; // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
List<String> embed = Arrays.asList("embed_example"); // List<String> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
String i4lProcessUid = "i4lProcessUid_example"; // String | Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
try {
    ModelsEndpointType result = apiInstance.updateModels(modelUid, patchmodel, envelope, embed, i4lProcessUid);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ModelsApi#updateModels");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **modelUid** | **String**| Model  UID |
 **patchmodel** | [**RFC6902PatchRequest**](RFC6902PatchRequest.md)| Update data |
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] [enum: yes, no]
 **embed** | [**List&lt;String&gt;**](String.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional]
 **i4lProcessUid** | **String**| Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. | [optional]

### Return type

[**ModelsEndpointType**](ModelsEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

