# ProcessesApi

All URIs are relative to *https://platform.its4land.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**createProcessLog**](ProcessesApi.md#createProcessLog) | **POST** /processes/{process_uid}/log | Writes a single log entry
[**createProcesses**](ProcessesApi.md#createProcesses) | **POST** /processes | Creates a new  processes
[**getProcessByUID**](ProcessesApi.md#getProcessByUID) | **GET** /processes/{process_uid} | Returns metadata for a single process
[**getProcessLog**](ProcessesApi.md#getProcessLog) | **GET** /processes/{process_uid}/log | Get the full log of a process
[**getProcesses**](ProcessesApi.md#getProcesses) | **GET** /processes | Get a list of processes


<a name="createProcessLog"></a>
# **createProcessLog**
> LogEntryEndpointType createProcessLog(processUid, newlogentry, envelope, i4lProcessUid)

Writes a single log entry

Writes a single log entry

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.ProcessesApi;


ProcessesApi apiInstance = new ProcessesApi();
String processUid = "processUid_example"; // String | Process UID
LogEntryPostRequest newlogentry = new LogEntryPostRequest(); // LogEntryPostRequest | New log entry
String envelope = "envelope_example"; // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
String i4lProcessUid = "i4lProcessUid_example"; // String | Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
try {
    LogEntryEndpointType result = apiInstance.createProcessLog(processUid, newlogentry, envelope, i4lProcessUid);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ProcessesApi#createProcessLog");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **processUid** | **String**| Process UID |
 **newlogentry** | [**LogEntryPostRequest**](LogEntryPostRequest.md)| New log entry |
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] [enum: yes, no]
 **i4lProcessUid** | **String**| Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. | [optional]

### Return type

[**LogEntryEndpointType**](LogEntryEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="createProcesses"></a>
# **createProcesses**
> ProcessEndpointType createProcesses(newprocess, envelope, embed, i4lProcessUid)

Creates a new  processes

Creates a new  processes

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.ProcessesApi;


ProcessesApi apiInstance = new ProcessesApi();
ProcessPostRequest newprocess = new ProcessPostRequest(); // ProcessPostRequest | New process metadata
String envelope = "envelope_example"; // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
List<String> embed = Arrays.asList("embed_example"); // List<String> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
String i4lProcessUid = "i4lProcessUid_example"; // String | Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
try {
    ProcessEndpointType result = apiInstance.createProcesses(newprocess, envelope, embed, i4lProcessUid);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ProcessesApi#createProcesses");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **newprocess** | [**ProcessPostRequest**](ProcessPostRequest.md)| New process metadata |
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] [enum: yes, no]
 **embed** | [**List&lt;String&gt;**](String.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional]
 **i4lProcessUid** | **String**| Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. | [optional]

### Return type

[**ProcessEndpointType**](ProcessEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="getProcessByUID"></a>
# **getProcessByUID**
> ProcessEndpointType getProcessByUID(processUid, envelope, embed)

Returns metadata for a single process

Returns metadata for a single process

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.ProcessesApi;


ProcessesApi apiInstance = new ProcessesApi();
String processUid = "processUid_example"; // String | Process UID
String envelope = "envelope_example"; // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
List<String> embed = Arrays.asList("embed_example"); // List<String> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
try {
    ProcessEndpointType result = apiInstance.getProcessByUID(processUid, envelope, embed);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ProcessesApi#getProcessByUID");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **processUid** | **String**| Process UID |
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] [enum: yes, no]
 **embed** | [**List&lt;String&gt;**](String.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional]

### Return type

[**ProcessEndpointType**](ProcessEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="getProcessLog"></a>
# **getProcessLog**
> List&lt;LogEntryEndpointType&gt; getProcessLog(processUid, envelope, loglevel, logsource, page, sort, fields, embed)

Get the full log of a process

Get the full log of a process. Oldest entry first

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.ProcessesApi;


ProcessesApi apiInstance = new ProcessesApi();
String processUid = "processUid_example"; // String | Process UID
String envelope = "envelope_example"; // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
List<String> loglevel = Arrays.asList("loglevel_example"); // List<String> | LogLevel : error, info, warning, debug. Default is info. The higher order level includes the lower level
List<String> logsource = Arrays.asList("logsource_example"); // List<String> | Source of the log entry. Values: GUI, <ToolName>
Integer page = 56; // Integer | Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default.
String sort = "sort_example"; // String | The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by.
List<String> fields = Arrays.asList("fields_example"); // List<String> | Comma separated list of field names
List<String> embed = Arrays.asList("embed_example"); // List<String> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
try {
    List<LogEntryEndpointType> result = apiInstance.getProcessLog(processUid, envelope, loglevel, logsource, page, sort, fields, embed);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ProcessesApi#getProcessLog");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **processUid** | **String**| Process UID |
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] [enum: yes, no]
 **loglevel** | [**List&lt;String&gt;**](String.md)| LogLevel : error, info, warning, debug. Default is info. The higher order level includes the lower level | [optional]
 **logsource** | [**List&lt;String&gt;**](String.md)| Source of the log entry. Values: GUI, &lt;ToolName&gt; | [optional]
 **page** | **Integer**| Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. | [optional]
 **sort** | **String**| The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. | [optional]
 **fields** | [**List&lt;String&gt;**](String.md)| Comma separated list of field names | [optional]
 **embed** | [**List&lt;String&gt;**](String.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional]

### Return type

[**List&lt;LogEntryEndpointType&gt;**](LogEntryEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="getProcesses"></a>
# **getProcesses**
> List&lt;ProcessEndpointType&gt; getProcesses(envelope, uid, project, status, tooluid, page, sort, fields, embed)

Get a list of processes

Get a list of processes

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.ProcessesApi;


ProcessesApi apiInstance = new ProcessesApi();
String envelope = "envelope_example"; // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
List<String> uid = Arrays.asList("uid_example"); // List<String> | Comma separated list of Tag UID
List<String> project = Arrays.asList("project_example"); // List<String> | Comma separated list of project uid
String status = "status_example"; // String | Status of the project. Can be one of:   * WAITING: Process is queued for execution   * RUNNING: Process is currently executing   * FINISHED: Process terminated normally   * ABORTED: Process terminated unexpectedly   * ZOMBIE: Process is listed in the platform process table, but the internal (process) API has no information about it. Possible in case of historical/archived processes or due to platform error. 
List<String> tooluid = Arrays.asList("tooluid_example"); // List<String> | Comma separated list of tool UID
Integer page = 56; // Integer | Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default.
String sort = "sort_example"; // String | The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by.
List<String> fields = Arrays.asList("fields_example"); // List<String> | Comma separated list of fields
List<String> embed = Arrays.asList("embed_example"); // List<String> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
try {
    List<ProcessEndpointType> result = apiInstance.getProcesses(envelope, uid, project, status, tooluid, page, sort, fields, embed);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ProcessesApi#getProcesses");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] [enum: yes, no]
 **uid** | [**List&lt;String&gt;**](String.md)| Comma separated list of Tag UID | [optional]
 **project** | [**List&lt;String&gt;**](String.md)| Comma separated list of project uid | [optional]
 **status** | **String**| Status of the project. Can be one of:   * WAITING: Process is queued for execution   * RUNNING: Process is currently executing   * FINISHED: Process terminated normally   * ABORTED: Process terminated unexpectedly   * ZOMBIE: Process is listed in the platform process table, but the internal (process) API has no information about it. Possible in case of historical/archived processes or due to platform error.  | [optional] [enum: WAITING, RUNNING, FINISHED, ABORTED, ZOMBIE]
 **tooluid** | [**List&lt;String&gt;**](String.md)| Comma separated list of tool UID | [optional]
 **page** | **Integer**| Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. | [optional]
 **sort** | **String**| The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. | [optional]
 **fields** | [**List&lt;String&gt;**](String.md)| Comma separated list of fields | [optional]
 **embed** | [**List&lt;String&gt;**](String.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional]

### Return type

[**List&lt;ProcessEndpointType&gt;**](ProcessEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

