# SpatialSourcesApi

All URIs are relative to *https://platform.its4land.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**detachSpatialSourceAddDoc**](SpatialSourcesApi.md#detachSpatialSourceAddDoc) | **DELETE** /spatialsource/{spatialsource_uid}/AdditionalDocument/{adddoc_uid} | Removes an additional document for a spatial source.
[**getSpatialSourceAddDocs**](SpatialSourcesApi.md#getSpatialSourceAddDocs) | **GET** /spatialsource/{spatialsource_uid}/AdditionalDocument | Returns the additional documents of a spatial source
[**getSpatialSourceByUID**](SpatialSourcesApi.md#getSpatialSourceByUID) | **GET** /spatialsource/{spatialsource_uid} | Returns a single SpatialSource
[**getSpatialSourceSingleAddDoc**](SpatialSourcesApi.md#getSpatialSourceSingleAddDoc) | **GET** /spatialsource/{spatialsource_uid}/AdditionalDocument/{adddoc_uid} | Returns the additional documents of a spatial source
[**getSpatialSources**](SpatialSourcesApi.md#getSpatialSources) | **GET** /spatialsources | Returns a list of SpatialSources
[**newSpatialSource**](SpatialSourcesApi.md#newSpatialSource) | **POST** /spatialsources | Create a new SpatialSource
[**newSpatialSourceAddAddDoc**](SpatialSourcesApi.md#newSpatialSourceAddAddDoc) | **POST** /spatialsource/{spatialsource_uid}/AdditionalDocument | Add a new additional document to a spatial source
[**putSpatialSourceByUID**](SpatialSourcesApi.md#putSpatialSourceByUID) | **PUT** /spatialsource/{spatialsource_uid} | Replace an existing SpatialSource by a newer version


<a name="detachSpatialSourceAddDoc"></a>
# **detachSpatialSourceAddDoc**
> List&lt;SpatialSourcesEndpointType&gt; detachSpatialSourceAddDoc(spatialsourceUid, adddocUid, envelope, forceDelete)

Removes an additional document for a spatial source.

Removes an additional document for a spatial source. By default only the link between additional document and spatial source is removed.

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.SpatialSourcesApi;


SpatialSourcesApi apiInstance = new SpatialSourcesApi();
String spatialsourceUid = "spatialsourceUid_example"; // String | SpatialSource UID
String adddocUid = "adddocUid_example"; // String | SpatialSource UID
String envelope = "envelope_example"; // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
String forceDelete = "forceDelete_example"; // String | Deletes the additional document resource.
try {
    List<SpatialSourcesEndpointType> result = apiInstance.detachSpatialSourceAddDoc(spatialsourceUid, adddocUid, envelope, forceDelete);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling SpatialSourcesApi#detachSpatialSourceAddDoc");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **spatialsourceUid** | **String**| SpatialSource UID |
 **adddocUid** | **String**| SpatialSource UID |
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] [enum: yes, no]
 **forceDelete** | **String**| Deletes the additional document resource. | [optional]

### Return type

[**List&lt;SpatialSourcesEndpointType&gt;**](SpatialSourcesEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="getSpatialSourceAddDocs"></a>
# **getSpatialSourceAddDocs**
> List&lt;AdditionalDocumentsEndpointType&gt; getSpatialSourceAddDocs(spatialsourceUid, envelope, page, sort, fields)

Returns the additional documents of a spatial source

Returns the additional documents of a spatial source

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.SpatialSourcesApi;


SpatialSourcesApi apiInstance = new SpatialSourcesApi();
String spatialsourceUid = "spatialsourceUid_example"; // String | SpatialSource UID
String envelope = "envelope_example"; // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
Integer page = 56; // Integer | Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default.
String sort = "sort_example"; // String | The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by.
List<String> fields = Arrays.asList("fields_example"); // List<String> | Comma separated list of field names
try {
    List<AdditionalDocumentsEndpointType> result = apiInstance.getSpatialSourceAddDocs(spatialsourceUid, envelope, page, sort, fields);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling SpatialSourcesApi#getSpatialSourceAddDocs");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **spatialsourceUid** | **String**| SpatialSource UID |
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] [enum: yes, no]
 **page** | **Integer**| Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. | [optional]
 **sort** | **String**| The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. | [optional]
 **fields** | [**List&lt;String&gt;**](String.md)| Comma separated list of field names | [optional]

### Return type

[**List&lt;AdditionalDocumentsEndpointType&gt;**](AdditionalDocumentsEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="getSpatialSourceByUID"></a>
# **getSpatialSourceByUID**
> SpatialSourcesEndpointType getSpatialSourceByUID(spatialsourceUid, envelope, embed)

Returns a single SpatialSource

Returns a single SpatialSource

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.SpatialSourcesApi;


SpatialSourcesApi apiInstance = new SpatialSourcesApi();
String spatialsourceUid = "spatialsourceUid_example"; // String | SpatialSource UID
String envelope = "envelope_example"; // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
List<String> embed = Arrays.asList("embed_example"); // List<String> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
try {
    SpatialSourcesEndpointType result = apiInstance.getSpatialSourceByUID(spatialsourceUid, envelope, embed);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling SpatialSourcesApi#getSpatialSourceByUID");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **spatialsourceUid** | **String**| SpatialSource UID |
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] [enum: yes, no]
 **embed** | [**List&lt;String&gt;**](String.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional]

### Return type

[**SpatialSourcesEndpointType**](SpatialSourcesEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="getSpatialSourceSingleAddDoc"></a>
# **getSpatialSourceSingleAddDoc**
> List&lt;AdditionalDocumentsEndpointType&gt; getSpatialSourceSingleAddDoc(spatialsourceUid, adddocUid, envelope, fields)

Returns the additional documents of a spatial source

Returns the additional documents of a spatial source

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.SpatialSourcesApi;


SpatialSourcesApi apiInstance = new SpatialSourcesApi();
String spatialsourceUid = "spatialsourceUid_example"; // String | SpatialSource UID
String adddocUid = "adddocUid_example"; // String | SpatialSource UID
String envelope = "envelope_example"; // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
List<String> fields = Arrays.asList("fields_example"); // List<String> | Comma separated list of field names
try {
    List<AdditionalDocumentsEndpointType> result = apiInstance.getSpatialSourceSingleAddDoc(spatialsourceUid, adddocUid, envelope, fields);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling SpatialSourcesApi#getSpatialSourceSingleAddDoc");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **spatialsourceUid** | **String**| SpatialSource UID |
 **adddocUid** | **String**| SpatialSource UID |
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] [enum: yes, no]
 **fields** | [**List&lt;String&gt;**](String.md)| Comma separated list of field names | [optional]

### Return type

[**List&lt;AdditionalDocumentsEndpointType&gt;**](AdditionalDocumentsEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="getSpatialSources"></a>
# **getSpatialSources**
> List&lt;SpatialSourcesEndpointType&gt; getSpatialSources(envelope, uid, name, type, projects, tags, page, sort, fields, embed)

Returns a list of SpatialSources

Returns a list of SpatialSources

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.SpatialSourcesApi;


SpatialSourcesApi apiInstance = new SpatialSourcesApi();
String envelope = "envelope_example"; // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
List<String> uid = Arrays.asList("uid_example"); // List<String> | Comma separated list of SpatialSources UID
List<String> name = Arrays.asList("name_example"); // List<String> | Comma separated list of SpatialSources names
List<String> type = Arrays.asList("type_example"); // List<String> | Comma separated list of SpatialSources types
List<String> projects = Arrays.asList("projects_example"); // List<String> | Comma separated list of project UID
List<String> tags = Arrays.asList("tags_example"); // List<String> | Comma separated list of tags
Integer page = 56; // Integer | Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default.
String sort = "sort_example"; // String | The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by.
List<String> fields = Arrays.asList("fields_example"); // List<String> | Comma separated list of tags
List<String> embed = Arrays.asList("embed_example"); // List<String> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
try {
    List<SpatialSourcesEndpointType> result = apiInstance.getSpatialSources(envelope, uid, name, type, projects, tags, page, sort, fields, embed);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling SpatialSourcesApi#getSpatialSources");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] [enum: yes, no]
 **uid** | [**List&lt;String&gt;**](String.md)| Comma separated list of SpatialSources UID | [optional]
 **name** | [**List&lt;String&gt;**](String.md)| Comma separated list of SpatialSources names | [optional]
 **type** | [**List&lt;String&gt;**](String.md)| Comma separated list of SpatialSources types | [optional]
 **projects** | [**List&lt;String&gt;**](String.md)| Comma separated list of project UID | [optional]
 **tags** | [**List&lt;String&gt;**](String.md)| Comma separated list of tags | [optional]
 **page** | **Integer**| Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. | [optional]
 **sort** | **String**| The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. | [optional]
 **fields** | [**List&lt;String&gt;**](String.md)| Comma separated list of tags | [optional]
 **embed** | [**List&lt;String&gt;**](String.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional]

### Return type

[**List&lt;SpatialSourcesEndpointType&gt;**](SpatialSourcesEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="newSpatialSource"></a>
# **newSpatialSource**
> SpatialSourcesEndpointType newSpatialSource(newspatialsource, envelope, embed, processUid, i4lProcessUid)

Create a new SpatialSource

Create a new SpatialSource. To add a new SpatialSources , the content of SpatialSources  must be stored in advanced via the ContentItem endpoint.

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.SpatialSourcesApi;


SpatialSourcesApi apiInstance = new SpatialSourcesApi();
SpatialSourcesPostRequest newspatialsource = new SpatialSourcesPostRequest(); // SpatialSourcesPostRequest | New SpatialSource data
String envelope = "envelope_example"; // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
List<String> embed = Arrays.asList("embed_example"); // List<String> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
String processUid = "processUid_example"; // String | deprecated
String i4lProcessUid = "i4lProcessUid_example"; // String | Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
try {
    SpatialSourcesEndpointType result = apiInstance.newSpatialSource(newspatialsource, envelope, embed, processUid, i4lProcessUid);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling SpatialSourcesApi#newSpatialSource");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **newspatialsource** | [**SpatialSourcesPostRequest**](SpatialSourcesPostRequest.md)| New SpatialSource data |
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] [enum: yes, no]
 **embed** | [**List&lt;String&gt;**](String.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional]
 **processUid** | **String**| deprecated | [optional]
 **i4lProcessUid** | **String**| Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. | [optional]

### Return type

[**SpatialSourcesEndpointType**](SpatialSourcesEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="newSpatialSourceAddAddDoc"></a>
# **newSpatialSourceAddAddDoc**
> AdditionalDocumentsEndpointType newSpatialSourceAddAddDoc(spatialsourceUid, newadddocdata, envelope, i4lProcessUid)

Add a new additional document to a spatial source

Add a new additional document to a spatial source

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.SpatialSourcesApi;


SpatialSourcesApi apiInstance = new SpatialSourcesApi();
String spatialsourceUid = "spatialsourceUid_example"; // String | SpatialSource UID
AdditionalDocumentsPost newadddocdata = new AdditionalDocumentsPost(); // AdditionalDocumentsPost | New additional document data
String envelope = "envelope_example"; // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
String i4lProcessUid = "i4lProcessUid_example"; // String | Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
try {
    AdditionalDocumentsEndpointType result = apiInstance.newSpatialSourceAddAddDoc(spatialsourceUid, newadddocdata, envelope, i4lProcessUid);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling SpatialSourcesApi#newSpatialSourceAddAddDoc");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **spatialsourceUid** | **String**| SpatialSource UID |
 **newadddocdata** | [**AdditionalDocumentsPost**](AdditionalDocumentsPost.md)| New additional document data |
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] [enum: yes, no]
 **i4lProcessUid** | **String**| Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. | [optional]

### Return type

[**AdditionalDocumentsEndpointType**](AdditionalDocumentsEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

<a name="putSpatialSourceByUID"></a>
# **putSpatialSourceByUID**
> SpatialSourcesEndpointType putSpatialSourceByUID(spatialsourceUid, updatedspatialsource, envelope, embed, i4lProcessUid)

Replace an existing SpatialSource by a newer version

An existing SpatialSource will be replaced by a newer version. The UID of SpatialSource remains

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.SpatialSourcesApi;


SpatialSourcesApi apiInstance = new SpatialSourcesApi();
String spatialsourceUid = "spatialsourceUid_example"; // String | SpatialSource UID
SpatialSourcesPostRequest updatedspatialsource = new SpatialSourcesPostRequest(); // SpatialSourcesPostRequest | Updated spatial source
String envelope = "envelope_example"; // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
List<String> embed = Arrays.asList("embed_example"); // List<String> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
String i4lProcessUid = "i4lProcessUid_example"; // String | Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
try {
    SpatialSourcesEndpointType result = apiInstance.putSpatialSourceByUID(spatialsourceUid, updatedspatialsource, envelope, embed, i4lProcessUid);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling SpatialSourcesApi#putSpatialSourceByUID");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **spatialsourceUid** | **String**| SpatialSource UID |
 **updatedspatialsource** | [**SpatialSourcesPostRequest**](SpatialSourcesPostRequest.md)| Updated spatial source |
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] [enum: yes, no]
 **embed** | [**List&lt;String&gt;**](String.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional]
 **i4lProcessUid** | **String**| Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. | [optional]

### Return type

[**SpatialSourcesEndpointType**](SpatialSourcesEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

