# ToolsApi

All URIs are relative to *https://platform.its4land.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**getTools**](ToolsApi.md#getTools) | **GET** /tools | Get a list of tools


<a name="getTools"></a>
# **getTools**
> List&lt;ToolsEndpointType&gt; getTools(envelope, uid, name, version, supplier, page, sort, fields, embed)

Get a list of tools

Get a list of tools

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.ToolsApi;


ToolsApi apiInstance = new ToolsApi();
String envelope = "envelope_example"; // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
List<String> uid = Arrays.asList("uid_example"); // List<String> | Comma separated list of Tag UID
List<String> name = Arrays.asList("name_example"); // List<String> | Comma separated list of tool names
String version = "version_example"; // String | Tool version. By default, the latest version will be returned. * returns all versions.
List<String> supplier = Arrays.asList("supplier_example"); // List<String> | Comma separated list of supplier
Integer page = 56; // Integer | Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default.
String sort = "sort_example"; // String | The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by.
List<String> fields = Arrays.asList("fields_example"); // List<String> | Comma separated list of fields
List<String> embed = Arrays.asList("embed_example"); // List<String> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
try {
    List<ToolsEndpointType> result = apiInstance.getTools(envelope, uid, name, version, supplier, page, sort, fields, embed);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ToolsApi#getTools");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] [enum: yes, no]
 **uid** | [**List&lt;String&gt;**](String.md)| Comma separated list of Tag UID | [optional]
 **name** | [**List&lt;String&gt;**](String.md)| Comma separated list of tool names | [optional]
 **version** | **String**| Tool version. By default, the latest version will be returned. * returns all versions. | [optional]
 **supplier** | [**List&lt;String&gt;**](String.md)| Comma separated list of supplier | [optional]
 **page** | **Integer**| Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. | [optional]
 **sort** | **String**| The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. | [optional]
 **fields** | [**List&lt;String&gt;**](String.md)| Comma separated list of fields | [optional]
 **embed** | [**List&lt;String&gt;**](String.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional]

### Return type

[**List&lt;ToolsEndpointType&gt;**](ToolsEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

