# TrainingSetsApi

All URIs are relative to *https://platform.its4land.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**getTrainingSetByUID**](TrainingSetsApi.md#getTrainingSetByUID) | **GET** /trainingsets/{trainingsets_uid} | Returns a single TrainingSet
[**getTrainingSets**](TrainingSetsApi.md#getTrainingSets) | **GET** /trainingsets | Returns a list of TrainingSets
[**newTrainingSet**](TrainingSetsApi.md#newTrainingSet) | **POST** /trainingsets | Create a new TrainingSet


<a name="getTrainingSetByUID"></a>
# **getTrainingSetByUID**
> TrainingsSetEndpointType getTrainingSetByUID(trainingsetsUid, envelope, embed)

Returns a single TrainingSet

Returns a single TrainingSet

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.TrainingSetsApi;


TrainingSetsApi apiInstance = new TrainingSetsApi();
String trainingsetsUid = "trainingsetsUid_example"; // String | TrainingSet UID
String envelope = "envelope_example"; // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
List<String> embed = Arrays.asList("embed_example"); // List<String> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
try {
    TrainingsSetEndpointType result = apiInstance.getTrainingSetByUID(trainingsetsUid, envelope, embed);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling TrainingSetsApi#getTrainingSetByUID");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **trainingsetsUid** | **String**| TrainingSet UID |
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] [enum: yes, no]
 **embed** | [**List&lt;String&gt;**](String.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional]

### Return type

[**TrainingsSetEndpointType**](TrainingsSetEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="getTrainingSets"></a>
# **getTrainingSets**
> List&lt;TrainingsSetEndpointType&gt; getTrainingSets(envelope, uid, name, models, tags, page, sort, fields, embed)

Returns a list of TrainingSets

Returns a list of TrainingSets

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.TrainingSetsApi;


TrainingSetsApi apiInstance = new TrainingSetsApi();
String envelope = "envelope_example"; // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
List<String> uid = Arrays.asList("uid_example"); // List<String> | Comma separated list of TrainingSet UID
List<String> name = Arrays.asList("name_example"); // List<String> | Comma separated list of TrainingSet Names
List<String> models = Arrays.asList("models_example"); // List<String> | Comma separated list of model UID
List<String> tags = Arrays.asList("tags_example"); // List<String> | Comma separated list of tags
Integer page = 56; // Integer | Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default.
String sort = "sort_example"; // String | The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by.
List<String> fields = Arrays.asList("fields_example"); // List<String> | Comma separated list of field names
List<String> embed = Arrays.asList("embed_example"); // List<String> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
try {
    List<TrainingsSetEndpointType> result = apiInstance.getTrainingSets(envelope, uid, name, models, tags, page, sort, fields, embed);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling TrainingSetsApi#getTrainingSets");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] [enum: yes, no]
 **uid** | [**List&lt;String&gt;**](String.md)| Comma separated list of TrainingSet UID | [optional]
 **name** | [**List&lt;String&gt;**](String.md)| Comma separated list of TrainingSet Names | [optional]
 **models** | [**List&lt;String&gt;**](String.md)| Comma separated list of model UID | [optional]
 **tags** | [**List&lt;String&gt;**](String.md)| Comma separated list of tags | [optional]
 **page** | **Integer**| Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. | [optional]
 **sort** | **String**| The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. | [optional]
 **fields** | [**List&lt;String&gt;**](String.md)| Comma separated list of field names | [optional]
 **embed** | [**List&lt;String&gt;**](String.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional]

### Return type

[**List&lt;TrainingsSetEndpointType&gt;**](TrainingsSetEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="newTrainingSet"></a>
# **newTrainingSet**
> TrainingsSetEndpointType newTrainingSet(newtrainingset, envelope, embed, i4lProcessUid)

Create a new TrainingSet

Create a new TrainingSet. To add a new TrainingSet , the content of TrainingSet  must be stored in advanced via the ContentItem endpoint

### Example
```java
// Import classes:
//import io.swagger.client.ApiException;
//import io.swagger.client.api.TrainingSetsApi;


TrainingSetsApi apiInstance = new TrainingSetsApi();
TrainingSetsPostRequest newtrainingset = new TrainingSetsPostRequest(); // TrainingSetsPostRequest | New TrainingSet data
String envelope = "envelope_example"; // String | The endpoint can package everything (header, status code) neatly into the response body. Include envelope=true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body.
List<String> embed = Arrays.asList("embed_example"); // List<String> | Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name)
String i4lProcessUid = "i4lProcessUid_example"; // String | Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process.
try {
    TrainingsSetEndpointType result = apiInstance.newTrainingSet(newtrainingset, envelope, embed, i4lProcessUid);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling TrainingSetsApi#newTrainingSet");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **newtrainingset** | [**TrainingSetsPostRequest**](TrainingSetsPostRequest.md)| New TrainingSet data |
 **envelope** | **String**| The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. | [optional] [enum: yes, no]
 **embed** | [**List&lt;String&gt;**](String.md)| Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) | [optional]
 **i4lProcessUid** | **String**| Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. | [optional]

### Return type

[**TrainingsSetEndpointType**](TrainingsSetEndpointType.md)

### Authorization

No authorization required

### HTTP request headers

 - **Content-Type**: application/json
 - **Accept**: application/json

