/*
 * its4land Public API
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.swagger.client.api;

import io.swagger.client.ApiCallback;
import io.swagger.client.ApiClient;
import io.swagger.client.ApiException;
import io.swagger.client.ApiResponse;
import io.swagger.client.Configuration;
import io.swagger.client.Pair;
import io.swagger.client.ProgressRequestBody;
import io.swagger.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import io.swagger.client.model.BoundaryFaceStringEndpointType;
import io.swagger.client.model.BoundaryFaceStringPostRequest;
import io.swagger.client.model.RFC6902PatchRequest;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class BoundaryFaceStringApi {
    private ApiClient apiClient;

    public BoundaryFaceStringApi() {
        this(Configuration.getDefaultApiClient());
    }

    public BoundaryFaceStringApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for getBoundaryFaceString
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param uid Comma separated list of Spatial unit UID (optional)
     * @param name Comma separated list of AdminSources names (optional)
     * @param projects Comma separated list of project UID (optional)
     * @param spatialunit Comma separated list of SpatialSource UID (optional)
     * @param tags Comma separated list of tags (optional)
     * @param page Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)
     * @param sort The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)
     * @param fields Comma separated list of tags (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getBoundaryFaceStringCall(String envelope, List<String> uid, List<String> name, List<String> projects, List<String> spatialunit, List<String> tags, Integer page, String sort, List<String> fields, List<String> embed, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/boundaryfacestring";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (envelope != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("envelope", envelope));
        if (uid != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("csv", "uid", uid));
        if (name != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("csv", "name", name));
        if (projects != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("csv", "projects", projects));
        if (spatialunit != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("csv", "spatialunit", spatialunit));
        if (tags != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("csv", "tags", tags));
        if (page != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("page", page));
        if (sort != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("sort", sort));
        if (fields != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("csv", "fields", fields));
        if (embed != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("csv", "embed", embed));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getBoundaryFaceStringValidateBeforeCall(String envelope, List<String> uid, List<String> name, List<String> projects, List<String> spatialunit, List<String> tags, Integer page, String sort, List<String> fields, List<String> embed, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        

        com.squareup.okhttp.Call call = getBoundaryFaceStringCall(envelope, uid, name, projects, spatialunit, tags, page, sort, fields, embed, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Returns a list of boundary face strings in a GeoJSON structure.
     * Returns a list of boundary face strings. A boundary face string is modeled as a GeoJSON feature.
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param uid Comma separated list of Spatial unit UID (optional)
     * @param name Comma separated list of AdminSources names (optional)
     * @param projects Comma separated list of project UID (optional)
     * @param spatialunit Comma separated list of SpatialSource UID (optional)
     * @param tags Comma separated list of tags (optional)
     * @param page Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)
     * @param sort The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)
     * @param fields Comma separated list of tags (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @return BoundaryFaceStringEndpointType
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public BoundaryFaceStringEndpointType getBoundaryFaceString(String envelope, List<String> uid, List<String> name, List<String> projects, List<String> spatialunit, List<String> tags, Integer page, String sort, List<String> fields, List<String> embed) throws ApiException {
        ApiResponse<BoundaryFaceStringEndpointType> resp = getBoundaryFaceStringWithHttpInfo(envelope, uid, name, projects, spatialunit, tags, page, sort, fields, embed);
        return resp.getData();
    }

    /**
     * Returns a list of boundary face strings in a GeoJSON structure.
     * Returns a list of boundary face strings. A boundary face string is modeled as a GeoJSON feature.
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param uid Comma separated list of Spatial unit UID (optional)
     * @param name Comma separated list of AdminSources names (optional)
     * @param projects Comma separated list of project UID (optional)
     * @param spatialunit Comma separated list of SpatialSource UID (optional)
     * @param tags Comma separated list of tags (optional)
     * @param page Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)
     * @param sort The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)
     * @param fields Comma separated list of tags (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @return ApiResponse&lt;BoundaryFaceStringEndpointType&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<BoundaryFaceStringEndpointType> getBoundaryFaceStringWithHttpInfo(String envelope, List<String> uid, List<String> name, List<String> projects, List<String> spatialunit, List<String> tags, Integer page, String sort, List<String> fields, List<String> embed) throws ApiException {
        com.squareup.okhttp.Call call = getBoundaryFaceStringValidateBeforeCall(envelope, uid, name, projects, spatialunit, tags, page, sort, fields, embed, null, null);
        Type localVarReturnType = new TypeToken<BoundaryFaceStringEndpointType>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Returns a list of boundary face strings in a GeoJSON structure. (asynchronously)
     * Returns a list of boundary face strings. A boundary face string is modeled as a GeoJSON feature.
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param uid Comma separated list of Spatial unit UID (optional)
     * @param name Comma separated list of AdminSources names (optional)
     * @param projects Comma separated list of project UID (optional)
     * @param spatialunit Comma separated list of SpatialSource UID (optional)
     * @param tags Comma separated list of tags (optional)
     * @param page Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)
     * @param sort The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)
     * @param fields Comma separated list of tags (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getBoundaryFaceStringAsync(String envelope, List<String> uid, List<String> name, List<String> projects, List<String> spatialunit, List<String> tags, Integer page, String sort, List<String> fields, List<String> embed, final ApiCallback<BoundaryFaceStringEndpointType> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getBoundaryFaceStringValidateBeforeCall(envelope, uid, name, projects, spatialunit, tags, page, sort, fields, embed, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<BoundaryFaceStringEndpointType>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getBoundaryFaceStringByUID
     * @param boundaryfacestringUid Boundary face string UID (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getBoundaryFaceStringByUIDCall(String boundaryfacestringUid, String envelope, List<String> embed, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/boundaryfacestring/{boundaryfacestring_uid}"
            .replaceAll("\\{" + "boundaryfacestring_uid" + "\\}", apiClient.escapeString(boundaryfacestringUid.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (envelope != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("envelope", envelope));
        if (embed != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("csv", "embed", embed));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getBoundaryFaceStringByUIDValidateBeforeCall(String boundaryfacestringUid, String envelope, List<String> embed, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'boundaryfacestringUid' is set
        if (boundaryfacestringUid == null) {
            throw new ApiException("Missing the required parameter 'boundaryfacestringUid' when calling getBoundaryFaceStringByUID(Async)");
        }
        

        com.squareup.okhttp.Call call = getBoundaryFaceStringByUIDCall(boundaryfacestringUid, envelope, embed, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Returns a single boundary face string
     * Returns a boundary face string as GeoJSON as a feature in a GeoJSON structure.
     * @param boundaryfacestringUid Boundary face string UID (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @return BoundaryFaceStringEndpointType
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public BoundaryFaceStringEndpointType getBoundaryFaceStringByUID(String boundaryfacestringUid, String envelope, List<String> embed) throws ApiException {
        ApiResponse<BoundaryFaceStringEndpointType> resp = getBoundaryFaceStringByUIDWithHttpInfo(boundaryfacestringUid, envelope, embed);
        return resp.getData();
    }

    /**
     * Returns a single boundary face string
     * Returns a boundary face string as GeoJSON as a feature in a GeoJSON structure.
     * @param boundaryfacestringUid Boundary face string UID (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @return ApiResponse&lt;BoundaryFaceStringEndpointType&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<BoundaryFaceStringEndpointType> getBoundaryFaceStringByUIDWithHttpInfo(String boundaryfacestringUid, String envelope, List<String> embed) throws ApiException {
        com.squareup.okhttp.Call call = getBoundaryFaceStringByUIDValidateBeforeCall(boundaryfacestringUid, envelope, embed, null, null);
        Type localVarReturnType = new TypeToken<BoundaryFaceStringEndpointType>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Returns a single boundary face string (asynchronously)
     * Returns a boundary face string as GeoJSON as a feature in a GeoJSON structure.
     * @param boundaryfacestringUid Boundary face string UID (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getBoundaryFaceStringByUIDAsync(String boundaryfacestringUid, String envelope, List<String> embed, final ApiCallback<BoundaryFaceStringEndpointType> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getBoundaryFaceStringByUIDValidateBeforeCall(boundaryfacestringUid, envelope, embed, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<BoundaryFaceStringEndpointType>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for newBoundaryFaceString
     * @param newboundaryfacestring New boundary face string (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call newBoundaryFaceStringCall(BoundaryFaceStringPostRequest newboundaryfacestring, String envelope, List<String> embed, String i4lProcessUid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = newboundaryfacestring;

        // create path and map variables
        String localVarPath = "/boundaryfacestring";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (envelope != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("envelope", envelope));
        if (embed != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("csv", "embed", embed));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (i4lProcessUid != null)
        localVarHeaderParams.put("i4l-process-uid", apiClient.parameterToString(i4lProcessUid));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call newBoundaryFaceStringValidateBeforeCall(BoundaryFaceStringPostRequest newboundaryfacestring, String envelope, List<String> embed, String i4lProcessUid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'newboundaryfacestring' is set
        if (newboundaryfacestring == null) {
            throw new ApiException("Missing the required parameter 'newboundaryfacestring' when calling newBoundaryFaceString(Async)");
        }
        

        com.squareup.okhttp.Call call = newBoundaryFaceStringCall(newboundaryfacestring, envelope, embed, i4lProcessUid, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Create a new concept for a boundary face string
     * Create a new concept for a boundary face string.
     * @param newboundaryfacestring New boundary face string (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @return BoundaryFaceStringEndpointType
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public BoundaryFaceStringEndpointType newBoundaryFaceString(BoundaryFaceStringPostRequest newboundaryfacestring, String envelope, List<String> embed, String i4lProcessUid) throws ApiException {
        ApiResponse<BoundaryFaceStringEndpointType> resp = newBoundaryFaceStringWithHttpInfo(newboundaryfacestring, envelope, embed, i4lProcessUid);
        return resp.getData();
    }

    /**
     * Create a new concept for a boundary face string
     * Create a new concept for a boundary face string.
     * @param newboundaryfacestring New boundary face string (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @return ApiResponse&lt;BoundaryFaceStringEndpointType&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<BoundaryFaceStringEndpointType> newBoundaryFaceStringWithHttpInfo(BoundaryFaceStringPostRequest newboundaryfacestring, String envelope, List<String> embed, String i4lProcessUid) throws ApiException {
        com.squareup.okhttp.Call call = newBoundaryFaceStringValidateBeforeCall(newboundaryfacestring, envelope, embed, i4lProcessUid, null, null);
        Type localVarReturnType = new TypeToken<BoundaryFaceStringEndpointType>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Create a new concept for a boundary face string (asynchronously)
     * Create a new concept for a boundary face string.
     * @param newboundaryfacestring New boundary face string (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call newBoundaryFaceStringAsync(BoundaryFaceStringPostRequest newboundaryfacestring, String envelope, List<String> embed, String i4lProcessUid, final ApiCallback<BoundaryFaceStringEndpointType> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = newBoundaryFaceStringValidateBeforeCall(newboundaryfacestring, envelope, embed, i4lProcessUid, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<BoundaryFaceStringEndpointType>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for putBoundaryFaceStringByUID
     * @param boundaryfacestringUid Boundary face string UID (required)
     * @param updatedboundaryfacestring Updated boundary face string (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call putBoundaryFaceStringByUIDCall(String boundaryfacestringUid, BoundaryFaceStringPostRequest updatedboundaryfacestring, String envelope, List<String> embed, String i4lProcessUid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = updatedboundaryfacestring;

        // create path and map variables
        String localVarPath = "/boundaryfacestring/{boundaryfacestring_uid}"
            .replaceAll("\\{" + "boundaryfacestring_uid" + "\\}", apiClient.escapeString(boundaryfacestringUid.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (envelope != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("envelope", envelope));
        if (embed != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("csv", "embed", embed));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (i4lProcessUid != null)
        localVarHeaderParams.put("i4l-process-uid", apiClient.parameterToString(i4lProcessUid));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "PUT", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call putBoundaryFaceStringByUIDValidateBeforeCall(String boundaryfacestringUid, BoundaryFaceStringPostRequest updatedboundaryfacestring, String envelope, List<String> embed, String i4lProcessUid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'boundaryfacestringUid' is set
        if (boundaryfacestringUid == null) {
            throw new ApiException("Missing the required parameter 'boundaryfacestringUid' when calling putBoundaryFaceStringByUID(Async)");
        }
        
        // verify the required parameter 'updatedboundaryfacestring' is set
        if (updatedboundaryfacestring == null) {
            throw new ApiException("Missing the required parameter 'updatedboundaryfacestring' when calling putBoundaryFaceStringByUID(Async)");
        }
        

        com.squareup.okhttp.Call call = putBoundaryFaceStringByUIDCall(boundaryfacestringUid, updatedboundaryfacestring, envelope, embed, i4lProcessUid, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Replace an existing BoundaryFaceString by a newer version
     * An existing BoundaryFaceString will be replaced by a newer version. The UID of BoundaryFaceString remains
     * @param boundaryfacestringUid Boundary face string UID (required)
     * @param updatedboundaryfacestring Updated boundary face string (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @return BoundaryFaceStringEndpointType
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public BoundaryFaceStringEndpointType putBoundaryFaceStringByUID(String boundaryfacestringUid, BoundaryFaceStringPostRequest updatedboundaryfacestring, String envelope, List<String> embed, String i4lProcessUid) throws ApiException {
        ApiResponse<BoundaryFaceStringEndpointType> resp = putBoundaryFaceStringByUIDWithHttpInfo(boundaryfacestringUid, updatedboundaryfacestring, envelope, embed, i4lProcessUid);
        return resp.getData();
    }

    /**
     * Replace an existing BoundaryFaceString by a newer version
     * An existing BoundaryFaceString will be replaced by a newer version. The UID of BoundaryFaceString remains
     * @param boundaryfacestringUid Boundary face string UID (required)
     * @param updatedboundaryfacestring Updated boundary face string (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @return ApiResponse&lt;BoundaryFaceStringEndpointType&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<BoundaryFaceStringEndpointType> putBoundaryFaceStringByUIDWithHttpInfo(String boundaryfacestringUid, BoundaryFaceStringPostRequest updatedboundaryfacestring, String envelope, List<String> embed, String i4lProcessUid) throws ApiException {
        com.squareup.okhttp.Call call = putBoundaryFaceStringByUIDValidateBeforeCall(boundaryfacestringUid, updatedboundaryfacestring, envelope, embed, i4lProcessUid, null, null);
        Type localVarReturnType = new TypeToken<BoundaryFaceStringEndpointType>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Replace an existing BoundaryFaceString by a newer version (asynchronously)
     * An existing BoundaryFaceString will be replaced by a newer version. The UID of BoundaryFaceString remains
     * @param boundaryfacestringUid Boundary face string UID (required)
     * @param updatedboundaryfacestring Updated boundary face string (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param embed Embedding is triggered by passing in an embed query parameter, which takes a comma separated list of endpoint types. Single fields can be selected a dot-notation (endpoint-type.property-name) (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call putBoundaryFaceStringByUIDAsync(String boundaryfacestringUid, BoundaryFaceStringPostRequest updatedboundaryfacestring, String envelope, List<String> embed, String i4lProcessUid, final ApiCallback<BoundaryFaceStringEndpointType> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = putBoundaryFaceStringByUIDValidateBeforeCall(boundaryfacestringUid, updatedboundaryfacestring, envelope, embed, i4lProcessUid, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<BoundaryFaceStringEndpointType>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for updateBoundaryFaceString
     * @param boundaryfacestringUid Boundary face string UID (required)
     * @param patchboundaryfacestring Update data (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call updateBoundaryFaceStringCall(String boundaryfacestringUid, RFC6902PatchRequest patchboundaryfacestring, String envelope, String i4lProcessUid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = patchboundaryfacestring;

        // create path and map variables
        String localVarPath = "/boundaryfacestring/{boundaryfacestring_uid}"
            .replaceAll("\\{" + "boundaryfacestring_uid" + "\\}", apiClient.escapeString(boundaryfacestringUid.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (envelope != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("envelope", envelope));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (i4lProcessUid != null)
        localVarHeaderParams.put("i4l-process-uid", apiClient.parameterToString(i4lProcessUid));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "PATCH", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call updateBoundaryFaceStringValidateBeforeCall(String boundaryfacestringUid, RFC6902PatchRequest patchboundaryfacestring, String envelope, String i4lProcessUid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'boundaryfacestringUid' is set
        if (boundaryfacestringUid == null) {
            throw new ApiException("Missing the required parameter 'boundaryfacestringUid' when calling updateBoundaryFaceString(Async)");
        }
        
        // verify the required parameter 'patchboundaryfacestring' is set
        if (patchboundaryfacestring == null) {
            throw new ApiException("Missing the required parameter 'patchboundaryfacestring' when calling updateBoundaryFaceString(Async)");
        }
        

        com.squareup.okhttp.Call call = updateBoundaryFaceStringCall(boundaryfacestringUid, patchboundaryfacestring, envelope, i4lProcessUid, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Updates a boundary face string
     * Updates a boundary face string
     * @param boundaryfacestringUid Boundary face string UID (required)
     * @param patchboundaryfacestring Update data (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @return BoundaryFaceStringEndpointType
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public BoundaryFaceStringEndpointType updateBoundaryFaceString(String boundaryfacestringUid, RFC6902PatchRequest patchboundaryfacestring, String envelope, String i4lProcessUid) throws ApiException {
        ApiResponse<BoundaryFaceStringEndpointType> resp = updateBoundaryFaceStringWithHttpInfo(boundaryfacestringUid, patchboundaryfacestring, envelope, i4lProcessUid);
        return resp.getData();
    }

    /**
     * Updates a boundary face string
     * Updates a boundary face string
     * @param boundaryfacestringUid Boundary face string UID (required)
     * @param patchboundaryfacestring Update data (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @return ApiResponse&lt;BoundaryFaceStringEndpointType&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<BoundaryFaceStringEndpointType> updateBoundaryFaceStringWithHttpInfo(String boundaryfacestringUid, RFC6902PatchRequest patchboundaryfacestring, String envelope, String i4lProcessUid) throws ApiException {
        com.squareup.okhttp.Call call = updateBoundaryFaceStringValidateBeforeCall(boundaryfacestringUid, patchboundaryfacestring, envelope, i4lProcessUid, null, null);
        Type localVarReturnType = new TypeToken<BoundaryFaceStringEndpointType>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Updates a boundary face string (asynchronously)
     * Updates a boundary face string
     * @param boundaryfacestringUid Boundary face string UID (required)
     * @param patchboundaryfacestring Update data (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call updateBoundaryFaceStringAsync(String boundaryfacestringUid, RFC6902PatchRequest patchboundaryfacestring, String envelope, String i4lProcessUid, final ApiCallback<BoundaryFaceStringEndpointType> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = updateBoundaryFaceStringValidateBeforeCall(boundaryfacestringUid, patchboundaryfacestring, envelope, i4lProcessUid, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<BoundaryFaceStringEndpointType>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
