/*
 * its4land Public API
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.swagger.client.api;

import io.swagger.client.ApiCallback;
import io.swagger.client.ApiClient;
import io.swagger.client.ApiException;
import io.swagger.client.ApiResponse;
import io.swagger.client.Configuration;
import io.swagger.client.Pair;
import io.swagger.client.ProgressRequestBody;
import io.swagger.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import io.swagger.client.model.ModelClassesEndpointType;
import io.swagger.client.model.RFC6902PatchRequest;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class ModelClassesApi {
    private ApiClient apiClient;

    public ModelClassesApi() {
        this(Configuration.getDefaultApiClient());
    }

    public ModelClassesApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /**
     * Build call for getModelClasses
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param UID Comma separated list of ModelClasses UID (optional)
     * @param nameinmodel Comma separated list of ModelClasses names (optional)
     * @param conceptname Comma separated list of ModelClasses concept names (optional)
     * @param page Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)
     * @param sort The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)
     * @param fields Comma separated list of field names (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getModelClassesCall(String envelope, List<String> UID, List<String> nameinmodel, List<String> conceptname, Integer page, String sort, List<String> fields, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/modelclasses";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (envelope != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("envelope", envelope));
        if (UID != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("csv", "UID", UID));
        if (nameinmodel != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("csv", "nameinmodel", nameinmodel));
        if (conceptname != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("csv", "conceptname", conceptname));
        if (page != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("page", page));
        if (sort != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("sort", sort));
        if (fields != null)
        localVarCollectionQueryParams.addAll(apiClient.parameterToPairs("csv", "fields", fields));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getModelClassesValidateBeforeCall(String envelope, List<String> UID, List<String> nameinmodel, List<String> conceptname, Integer page, String sort, List<String> fields, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        

        com.squareup.okhttp.Call call = getModelClassesCall(envelope, UID, nameinmodel, conceptname, page, sort, fields, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Returns ModelClasses
     * Returns ModelClasses
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param UID Comma separated list of ModelClasses UID (optional)
     * @param nameinmodel Comma separated list of ModelClasses names (optional)
     * @param conceptname Comma separated list of ModelClasses concept names (optional)
     * @param page Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)
     * @param sort The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)
     * @param fields Comma separated list of field names (optional)
     * @return List&lt;ModelClassesEndpointType&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<ModelClassesEndpointType> getModelClasses(String envelope, List<String> UID, List<String> nameinmodel, List<String> conceptname, Integer page, String sort, List<String> fields) throws ApiException {
        ApiResponse<List<ModelClassesEndpointType>> resp = getModelClassesWithHttpInfo(envelope, UID, nameinmodel, conceptname, page, sort, fields);
        return resp.getData();
    }

    /**
     * Returns ModelClasses
     * Returns ModelClasses
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param UID Comma separated list of ModelClasses UID (optional)
     * @param nameinmodel Comma separated list of ModelClasses names (optional)
     * @param conceptname Comma separated list of ModelClasses concept names (optional)
     * @param page Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)
     * @param sort The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)
     * @param fields Comma separated list of field names (optional)
     * @return ApiResponse&lt;List&lt;ModelClassesEndpointType&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<ModelClassesEndpointType>> getModelClassesWithHttpInfo(String envelope, List<String> UID, List<String> nameinmodel, List<String> conceptname, Integer page, String sort, List<String> fields) throws ApiException {
        com.squareup.okhttp.Call call = getModelClassesValidateBeforeCall(envelope, UID, nameinmodel, conceptname, page, sort, fields, null, null);
        Type localVarReturnType = new TypeToken<List<ModelClassesEndpointType>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Returns ModelClasses (asynchronously)
     * Returns ModelClasses
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param UID Comma separated list of ModelClasses UID (optional)
     * @param nameinmodel Comma separated list of ModelClasses names (optional)
     * @param conceptname Comma separated list of ModelClasses concept names (optional)
     * @param page Requests for collections can return between 0 and N results, controlled using the per_page and page query parameters. All endpoints are limited to 10 results by default. (optional)
     * @param sort The sorting is initiated by the sort query parameter and a list of comma separated list of fields to sort by. (optional)
     * @param fields Comma separated list of field names (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getModelClassesAsync(String envelope, List<String> UID, List<String> nameinmodel, List<String> conceptname, Integer page, String sort, List<String> fields, final ApiCallback<List<ModelClassesEndpointType>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getModelClassesValidateBeforeCall(envelope, UID, nameinmodel, conceptname, page, sort, fields, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<ModelClassesEndpointType>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for getModelClassesByUID
     * @param modelclassesUid ModelClass UID (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call getModelClassesByUIDCall(String modelclassesUid, String envelope, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;

        // create path and map variables
        String localVarPath = "/modelclasses/{modelclasses_uid}"
            .replaceAll("\\{" + "modelclasses_uid" + "\\}", apiClient.escapeString(modelclassesUid.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (envelope != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("envelope", envelope));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call getModelClassesByUIDValidateBeforeCall(String modelclassesUid, String envelope, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'modelclassesUid' is set
        if (modelclassesUid == null) {
            throw new ApiException("Missing the required parameter 'modelclassesUid' when calling getModelClassesByUID(Async)");
        }
        

        com.squareup.okhttp.Call call = getModelClassesByUIDCall(modelclassesUid, envelope, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Returns a single model class
     * Returns a single model class
     * @param modelclassesUid ModelClass UID (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @return ModelClassesEndpointType
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ModelClassesEndpointType getModelClassesByUID(String modelclassesUid, String envelope) throws ApiException {
        ApiResponse<ModelClassesEndpointType> resp = getModelClassesByUIDWithHttpInfo(modelclassesUid, envelope);
        return resp.getData();
    }

    /**
     * Returns a single model class
     * Returns a single model class
     * @param modelclassesUid ModelClass UID (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @return ApiResponse&lt;ModelClassesEndpointType&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ModelClassesEndpointType> getModelClassesByUIDWithHttpInfo(String modelclassesUid, String envelope) throws ApiException {
        com.squareup.okhttp.Call call = getModelClassesByUIDValidateBeforeCall(modelclassesUid, envelope, null, null);
        Type localVarReturnType = new TypeToken<ModelClassesEndpointType>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Returns a single model class (asynchronously)
     * Returns a single model class
     * @param modelclassesUid ModelClass UID (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call getModelClassesByUIDAsync(String modelclassesUid, String envelope, final ApiCallback<ModelClassesEndpointType> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = getModelClassesByUIDValidateBeforeCall(modelclassesUid, envelope, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ModelClassesEndpointType>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for updateModelClasses
     * @param modelclassesUid ModelClass UID (required)
     * @param patchmodelclasses Update data (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call updateModelClassesCall(String modelclassesUid, RFC6902PatchRequest patchmodelclasses, String envelope, String i4lProcessUid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = patchmodelclasses;

        // create path and map variables
        String localVarPath = "/modelclasses/{modelclasses_uid}"
            .replaceAll("\\{" + "modelclasses_uid" + "\\}", apiClient.escapeString(modelclassesUid.toString()));

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (envelope != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("envelope", envelope));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();
        if (i4lProcessUid != null)
        localVarHeaderParams.put("i4l-process-uid", apiClient.parameterToString(i4lProcessUid));

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "application/json"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] {  };
        return apiClient.buildCall(localVarPath, "PATCH", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }

    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call updateModelClassesValidateBeforeCall(String modelclassesUid, RFC6902PatchRequest patchmodelclasses, String envelope, String i4lProcessUid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'modelclassesUid' is set
        if (modelclassesUid == null) {
            throw new ApiException("Missing the required parameter 'modelclassesUid' when calling updateModelClasses(Async)");
        }
        
        // verify the required parameter 'patchmodelclasses' is set
        if (patchmodelclasses == null) {
            throw new ApiException("Missing the required parameter 'patchmodelclasses' when calling updateModelClasses(Async)");
        }
        

        com.squareup.okhttp.Call call = updateModelClassesCall(modelclassesUid, patchmodelclasses, envelope, i4lProcessUid, progressListener, progressRequestListener);
        return call;

    }

    /**
     * Updates some attributes of a ModelClass
     * Updates some attributes of a ModelClass
     * @param modelclassesUid ModelClass UID (required)
     * @param patchmodelclasses Update data (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @return ModelClassesEndpointType
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ModelClassesEndpointType updateModelClasses(String modelclassesUid, RFC6902PatchRequest patchmodelclasses, String envelope, String i4lProcessUid) throws ApiException {
        ApiResponse<ModelClassesEndpointType> resp = updateModelClassesWithHttpInfo(modelclassesUid, patchmodelclasses, envelope, i4lProcessUid);
        return resp.getData();
    }

    /**
     * Updates some attributes of a ModelClass
     * Updates some attributes of a ModelClass
     * @param modelclassesUid ModelClass UID (required)
     * @param patchmodelclasses Update data (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @return ApiResponse&lt;ModelClassesEndpointType&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ModelClassesEndpointType> updateModelClassesWithHttpInfo(String modelclassesUid, RFC6902PatchRequest patchmodelclasses, String envelope, String i4lProcessUid) throws ApiException {
        com.squareup.okhttp.Call call = updateModelClassesValidateBeforeCall(modelclassesUid, patchmodelclasses, envelope, i4lProcessUid, null, null);
        Type localVarReturnType = new TypeToken<ModelClassesEndpointType>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Updates some attributes of a ModelClass (asynchronously)
     * Updates some attributes of a ModelClass
     * @param modelclassesUid ModelClass UID (required)
     * @param patchmodelclasses Update data (required)
     * @param envelope The endpoint can package everything (header, status code) neatly into the response body. Include envelope&#x3D;true as a request parameter. The API will always return a 200 HTTP status code. The real status, headers and response will be within the body. (optional)
     * @param i4lProcessUid Process UID. This parameter can be used by an its4land tool running inside the runtime environment to pass the process uid to the endpoint. With this information the endpoint can associate the newly created or updated resource with the process. (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call updateModelClassesAsync(String modelclassesUid, RFC6902PatchRequest patchmodelclasses, String envelope, String i4lProcessUid, final ApiCallback<ModelClassesEndpointType> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = updateModelClassesValidateBeforeCall(modelclassesUid, patchmodelclasses, envelope, i4lProcessUid, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ModelClassesEndpointType>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
