/*
 * its4land Public API
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.swagger.client.model;

import java.util.Objects;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.client.model.TrainingsSetEndpointTypeModels;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

/**
 * ClassifierPostRequest
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2019-10-11T17:16:59.919+02:00")
public class ClassifierPostRequest {
  @SerializedName("Name")
  private String name = null;

  @SerializedName("Description")
  private String description = null;

  @SerializedName("ClassifierType")
  private String classifierType = null;

  @SerializedName("Tools")
  private List<String> tools = null;

  @SerializedName("ContentItem")
  private String contentItem = null;

  @SerializedName("Tags")
  private List<String> tags = null;

  @SerializedName("Models")
  private List<TrainingsSetEndpointTypeModels> models = null;

  public ClassifierPostRequest name(String name) {
    this.name = name;
    return this;
  }

   /**
   * Freely chosen name
   * @return name
  **/
  @ApiModelProperty(value = "Freely chosen name")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public ClassifierPostRequest description(String description) {
    this.description = description;
    return this;
  }

   /**
   * Free text for description. Only plain text.
   * @return description
  **/
  @ApiModelProperty(value = "Free text for description. Only plain text.")
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

  public ClassifierPostRequest classifierType(String classifierType) {
    this.classifierType = classifierType;
    return this;
  }

   /**
   * Classifier type.
   * @return classifierType
  **/
  @ApiModelProperty(value = "Classifier type.")
  public String getClassifierType() {
    return classifierType;
  }

  public void setClassifierType(String classifierType) {
    this.classifierType = classifierType;
  }

  public ClassifierPostRequest tools(List<String> tools) {
    this.tools = tools;
    return this;
  }

  public ClassifierPostRequest addToolsItem(String toolsItem) {
    if (this.tools == null) {
      this.tools = new ArrayList<String>();
    }
    this.tools.add(toolsItem);
    return this;
  }

   /**
   * Comma separated list tool names which can make use of the classifier.
   * @return tools
  **/
  @ApiModelProperty(value = "Comma separated list tool names which can make use of the classifier.")
  public List<String> getTools() {
    return tools;
  }

  public void setTools(List<String> tools) {
    this.tools = tools;
  }

  public ClassifierPostRequest contentItem(String contentItem) {
    this.contentItem = contentItem;
    return this;
  }

   /**
   * UID of the ContentItem
   * @return contentItem
  **/
  @ApiModelProperty(value = "UID of the ContentItem")
  public String getContentItem() {
    return contentItem;
  }

  public void setContentItem(String contentItem) {
    this.contentItem = contentItem;
  }

  public ClassifierPostRequest tags(List<String> tags) {
    this.tags = tags;
    return this;
  }

  public ClassifierPostRequest addTagsItem(String tagsItem) {
    if (this.tags == null) {
      this.tags = new ArrayList<String>();
    }
    this.tags.add(tagsItem);
    return this;
  }

   /**
   * Array of tags (strings).
   * @return tags
  **/
  @ApiModelProperty(value = "Array of tags (strings).")
  public List<String> getTags() {
    return tags;
  }

  public void setTags(List<String> tags) {
    this.tags = tags;
  }

  public ClassifierPostRequest models(List<TrainingsSetEndpointTypeModels> models) {
    this.models = models;
    return this;
  }

  public ClassifierPostRequest addModelsItem(TrainingsSetEndpointTypeModels modelsItem) {
    if (this.models == null) {
      this.models = new ArrayList<TrainingsSetEndpointTypeModels>();
    }
    this.models.add(modelsItem);
    return this;
  }

   /**
   * Array of Projects (UID).
   * @return models
  **/
  @ApiModelProperty(value = "Array of Projects (UID).")
  public List<TrainingsSetEndpointTypeModels> getModels() {
    return models;
  }

  public void setModels(List<TrainingsSetEndpointTypeModels> models) {
    this.models = models;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ClassifierPostRequest classifierPostRequest = (ClassifierPostRequest) o;
    return Objects.equals(this.name, classifierPostRequest.name) &&
        Objects.equals(this.description, classifierPostRequest.description) &&
        Objects.equals(this.classifierType, classifierPostRequest.classifierType) &&
        Objects.equals(this.tools, classifierPostRequest.tools) &&
        Objects.equals(this.contentItem, classifierPostRequest.contentItem) &&
        Objects.equals(this.tags, classifierPostRequest.tags) &&
        Objects.equals(this.models, classifierPostRequest.models);
  }

  @Override
  public int hashCode() {
    return Objects.hash(name, description, classifierType, tools, contentItem, tags, models);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class ClassifierPostRequest {\n");
    
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    classifierType: ").append(toIndentedString(classifierType)).append("\n");
    sb.append("    tools: ").append(toIndentedString(tools)).append("\n");
    sb.append("    contentItem: ").append(toIndentedString(contentItem)).append("\n");
    sb.append("    tags: ").append(toIndentedString(tags)).append("\n");
    sb.append("    models: ").append(toIndentedString(models)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

