/*
 * its4land Public API
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.swagger.client.model;

import java.util.Objects;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.client.model.ModelsEndpointTypeProjects;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

/**
 * DDILayersPostRequest
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2019-10-11T17:16:59.919+02:00")
public class DDILayersPostRequest {
  @SerializedName("Name")
  private String name = null;

  @SerializedName("Description")
  private String description = null;

  @SerializedName("LongDescription")
  private String longDescription = null;

  @SerializedName("ExtDescriptionURL")
  private String extDescriptionURL = null;

  @SerializedName("Service")
  private String service = null;

  @SerializedName("EMName")
  private String emName = null;

  @SerializedName("ContentItems")
  private List<String> contentItems = null;

  @SerializedName("Tags")
  private List<String> tags = null;

  @SerializedName("Projects")
  private List<ModelsEndpointTypeProjects> projects = null;

  public DDILayersPostRequest name(String name) {
    this.name = name;
    return this;
  }

   /**
   * Layer name. Must be unique
   * @return name
  **/
  @ApiModelProperty(required = true, value = "Layer name. Must be unique")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public DDILayersPostRequest description(String description) {
    this.description = description;
    return this;
  }

   /**
   * Free text for description. Only plain text. Max 255 char.
   * @return description
  **/
  @ApiModelProperty(value = "Free text for description. Only plain text. Max 255 char.")
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

  public DDILayersPostRequest longDescription(String longDescription) {
    this.longDescription = longDescription;
    return this;
  }

   /**
   * Text for description. Can contain html. Max 4000 char.
   * @return longDescription
  **/
  @ApiModelProperty(value = "Text for description. Can contain html. Max 4000 char.")
  public String getLongDescription() {
    return longDescription;
  }

  public void setLongDescription(String longDescription) {
    this.longDescription = longDescription;
  }

  public DDILayersPostRequest extDescriptionURL(String extDescriptionURL) {
    this.extDescriptionURL = extDescriptionURL;
    return this;
  }

   /**
   * URL to an external description of the document.
   * @return extDescriptionURL
  **/
  @ApiModelProperty(value = "URL to an external description of the document.")
  public String getExtDescriptionURL() {
    return extDescriptionURL;
  }

  public void setExtDescriptionURL(String extDescriptionURL) {
    this.extDescriptionURL = extDescriptionURL;
  }

  public DDILayersPostRequest service(String service) {
    this.service = service;
    return this;
  }

   /**
   * Service type of the layer. WFS or WMS
   * @return service
  **/
  @ApiModelProperty(required = true, value = "Service type of the layer. WFS or WMS")
  public String getService() {
    return service;
  }

  public void setService(String service) {
    this.service = service;
  }

  public DDILayersPostRequest emName(String emName) {
    this.emName = emName;
    return this;
  }

   /**
   * When the Em repository is uesed, this paramter contains the name of the layer in the EM repository
   * @return emName
  **/
  @ApiModelProperty(value = "When the Em repository is uesed, this paramter contains the name of the layer in the EM repository")
  public String getEmName() {
    return emName;
  }

  public void setEmName(String emName) {
    this.emName = emName;
  }

  public DDILayersPostRequest contentItems(List<String> contentItems) {
    this.contentItems = contentItems;
    return this;
  }

  public DDILayersPostRequest addContentItemsItem(String contentItemsItem) {
    if (this.contentItems == null) {
      this.contentItems = new ArrayList<String>();
    }
    this.contentItems.add(contentItemsItem);
    return this;
  }

   /**
   * List of Images (ContenItems. Used for the DDI Service.
   * @return contentItems
  **/
  @ApiModelProperty(value = "List of Images (ContenItems. Used for the DDI Service.")
  public List<String> getContentItems() {
    return contentItems;
  }

  public void setContentItems(List<String> contentItems) {
    this.contentItems = contentItems;
  }

  public DDILayersPostRequest tags(List<String> tags) {
    this.tags = tags;
    return this;
  }

  public DDILayersPostRequest addTagsItem(String tagsItem) {
    if (this.tags == null) {
      this.tags = new ArrayList<String>();
    }
    this.tags.add(tagsItem);
    return this;
  }

   /**
   * Array of tags (strings).
   * @return tags
  **/
  @ApiModelProperty(value = "Array of tags (strings).")
  public List<String> getTags() {
    return tags;
  }

  public void setTags(List<String> tags) {
    this.tags = tags;
  }

  public DDILayersPostRequest projects(List<ModelsEndpointTypeProjects> projects) {
    this.projects = projects;
    return this;
  }

  public DDILayersPostRequest addProjectsItem(ModelsEndpointTypeProjects projectsItem) {
    if (this.projects == null) {
      this.projects = new ArrayList<ModelsEndpointTypeProjects>();
    }
    this.projects.add(projectsItem);
    return this;
  }

   /**
   * Array of Projects (UID).
   * @return projects
  **/
  @ApiModelProperty(value = "Array of Projects (UID).")
  public List<ModelsEndpointTypeProjects> getProjects() {
    return projects;
  }

  public void setProjects(List<ModelsEndpointTypeProjects> projects) {
    this.projects = projects;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    DDILayersPostRequest ddILayersPostRequest = (DDILayersPostRequest) o;
    return Objects.equals(this.name, ddILayersPostRequest.name) &&
        Objects.equals(this.description, ddILayersPostRequest.description) &&
        Objects.equals(this.longDescription, ddILayersPostRequest.longDescription) &&
        Objects.equals(this.extDescriptionURL, ddILayersPostRequest.extDescriptionURL) &&
        Objects.equals(this.service, ddILayersPostRequest.service) &&
        Objects.equals(this.emName, ddILayersPostRequest.emName) &&
        Objects.equals(this.contentItems, ddILayersPostRequest.contentItems) &&
        Objects.equals(this.tags, ddILayersPostRequest.tags) &&
        Objects.equals(this.projects, ddILayersPostRequest.projects);
  }

  @Override
  public int hashCode() {
    return Objects.hash(name, description, longDescription, extDescriptionURL, service, emName, contentItems, tags, projects);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class DDILayersPostRequest {\n");
    
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    longDescription: ").append(toIndentedString(longDescription)).append("\n");
    sb.append("    extDescriptionURL: ").append(toIndentedString(extDescriptionURL)).append("\n");
    sb.append("    service: ").append(toIndentedString(service)).append("\n");
    sb.append("    emName: ").append(toIndentedString(emName)).append("\n");
    sb.append("    contentItems: ").append(toIndentedString(contentItems)).append("\n");
    sb.append("    tags: ").append(toIndentedString(tags)).append("\n");
    sb.append("    projects: ").append(toIndentedString(projects)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

