/*
 * its4land Public API
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.swagger.client.model;

import java.util.Objects;
import com.google.gson.TypeAdapter;
import com.google.gson.annotations.JsonAdapter;
import com.google.gson.annotations.SerializedName;
import com.google.gson.stream.JsonReader;
import com.google.gson.stream.JsonWriter;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import io.swagger.client.model.TrainingsSetEndpointTypeModels;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

/**
 * TrainingSetsPostRequest
 */
@javax.annotation.Generated(value = "io.swagger.codegen.languages.JavaClientCodegen", date = "2019-10-11T17:16:59.919+02:00")
public class TrainingSetsPostRequest {
  @SerializedName("Name")
  private String name = null;

  @SerializedName("Description")
  private String description = null;

  @SerializedName("TrainingSetType")
  private String trainingSetType = null;

  @SerializedName("TrainingSetStatus")
  private Integer trainingSetStatus = null;

  @SerializedName("Tools")
  private List<String> tools = null;

  @SerializedName("ContentItem")
  private String contentItem = null;

  @SerializedName("Tags")
  private List<String> tags = null;

  @SerializedName("Models")
  private List<TrainingsSetEndpointTypeModels> models = null;

  public TrainingSetsPostRequest name(String name) {
    this.name = name;
    return this;
  }

   /**
   * Freely chosen name
   * @return name
  **/
  @ApiModelProperty(value = "Freely chosen name")
  public String getName() {
    return name;
  }

  public void setName(String name) {
    this.name = name;
  }

  public TrainingSetsPostRequest description(String description) {
    this.description = description;
    return this;
  }

   /**
   * Free text for description. Only plain text.
   * @return description
  **/
  @ApiModelProperty(value = "Free text for description. Only plain text.")
  public String getDescription() {
    return description;
  }

  public void setDescription(String description) {
    this.description = description;
  }

  public TrainingSetsPostRequest trainingSetType(String trainingSetType) {
    this.trainingSetType = trainingSetType;
    return this;
  }

   /**
   * TrainingSet type.
   * @return trainingSetType
  **/
  @ApiModelProperty(value = "TrainingSet type.")
  public String getTrainingSetType() {
    return trainingSetType;
  }

  public void setTrainingSetType(String trainingSetType) {
    this.trainingSetType = trainingSetType;
  }

  public TrainingSetsPostRequest trainingSetStatus(Integer trainingSetStatus) {
    this.trainingSetStatus = trainingSetStatus;
    return this;
  }

   /**
   * 0 &#x3D; untrained 1 &#x3D; trained
   * @return trainingSetStatus
  **/
  @ApiModelProperty(value = "0 = untrained 1 = trained")
  public Integer getTrainingSetStatus() {
    return trainingSetStatus;
  }

  public void setTrainingSetStatus(Integer trainingSetStatus) {
    this.trainingSetStatus = trainingSetStatus;
  }

  public TrainingSetsPostRequest tools(List<String> tools) {
    this.tools = tools;
    return this;
  }

  public TrainingSetsPostRequest addToolsItem(String toolsItem) {
    if (this.tools == null) {
      this.tools = new ArrayList<String>();
    }
    this.tools.add(toolsItem);
    return this;
  }

   /**
   * Comma separated list tool names which can make use of the training set.
   * @return tools
  **/
  @ApiModelProperty(value = "Comma separated list tool names which can make use of the training set.")
  public List<String> getTools() {
    return tools;
  }

  public void setTools(List<String> tools) {
    this.tools = tools;
  }

  public TrainingSetsPostRequest contentItem(String contentItem) {
    this.contentItem = contentItem;
    return this;
  }

   /**
   * UID of the ContentItem
   * @return contentItem
  **/
  @ApiModelProperty(value = "UID of the ContentItem")
  public String getContentItem() {
    return contentItem;
  }

  public void setContentItem(String contentItem) {
    this.contentItem = contentItem;
  }

  public TrainingSetsPostRequest tags(List<String> tags) {
    this.tags = tags;
    return this;
  }

  public TrainingSetsPostRequest addTagsItem(String tagsItem) {
    if (this.tags == null) {
      this.tags = new ArrayList<String>();
    }
    this.tags.add(tagsItem);
    return this;
  }

   /**
   * Array of tags (strings).
   * @return tags
  **/
  @ApiModelProperty(value = "Array of tags (strings).")
  public List<String> getTags() {
    return tags;
  }

  public void setTags(List<String> tags) {
    this.tags = tags;
  }

  public TrainingSetsPostRequest models(List<TrainingsSetEndpointTypeModels> models) {
    this.models = models;
    return this;
  }

  public TrainingSetsPostRequest addModelsItem(TrainingsSetEndpointTypeModels modelsItem) {
    if (this.models == null) {
      this.models = new ArrayList<TrainingsSetEndpointTypeModels>();
    }
    this.models.add(modelsItem);
    return this;
  }

   /**
   * Array of Projects (UID).
   * @return models
  **/
  @ApiModelProperty(value = "Array of Projects (UID).")
  public List<TrainingsSetEndpointTypeModels> getModels() {
    return models;
  }

  public void setModels(List<TrainingsSetEndpointTypeModels> models) {
    this.models = models;
  }


  @Override
  public boolean equals(java.lang.Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    TrainingSetsPostRequest trainingSetsPostRequest = (TrainingSetsPostRequest) o;
    return Objects.equals(this.name, trainingSetsPostRequest.name) &&
        Objects.equals(this.description, trainingSetsPostRequest.description) &&
        Objects.equals(this.trainingSetType, trainingSetsPostRequest.trainingSetType) &&
        Objects.equals(this.trainingSetStatus, trainingSetsPostRequest.trainingSetStatus) &&
        Objects.equals(this.tools, trainingSetsPostRequest.tools) &&
        Objects.equals(this.contentItem, trainingSetsPostRequest.contentItem) &&
        Objects.equals(this.tags, trainingSetsPostRequest.tags) &&
        Objects.equals(this.models, trainingSetsPostRequest.models);
  }

  @Override
  public int hashCode() {
    return Objects.hash(name, description, trainingSetType, trainingSetStatus, tools, contentItem, tags, models);
  }


  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class TrainingSetsPostRequest {\n");
    
    sb.append("    name: ").append(toIndentedString(name)).append("\n");
    sb.append("    description: ").append(toIndentedString(description)).append("\n");
    sb.append("    trainingSetType: ").append(toIndentedString(trainingSetType)).append("\n");
    sb.append("    trainingSetStatus: ").append(toIndentedString(trainingSetStatus)).append("\n");
    sb.append("    tools: ").append(toIndentedString(tools)).append("\n");
    sb.append("    contentItem: ").append(toIndentedString(contentItem)).append("\n");
    sb.append("    tags: ").append(toIndentedString(tags)).append("\n");
    sb.append("    models: ").append(toIndentedString(models)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(java.lang.Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

