/*
 * its4land Public API
 * The its4land Public API provides access to the services of the its4land Publish and Share platform.
 *
 * OpenAPI spec version: 0.0.2
 * Contact: contact@its4land.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.swagger.client.api;

import io.swagger.client.ApiException;
import io.swagger.client.model.ConnectedObjectsEndpointType;
import io.swagger.client.model.ModelsEndpointType;
import io.swagger.client.model.ModelsPostRequest;
import io.swagger.client.model.ProjectsEndpointType;
import io.swagger.client.model.ProjectsPostRequest;
import io.swagger.client.model.RFC6902PatchRequest;
import io.swagger.client.model.SpatialSourcesEndpointType;
import io.swagger.client.model.SpatialSourcesPostRequest;
import io.swagger.client.model.TagsListResponse;
import io.swagger.client.model.TagsPostRequest;
import org.junit.Test;
import org.junit.Ignore;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * API tests for ProjectsApi
 */
@Ignore
public class ProjectsApiTest {

    private final ProjectsApi api = new ProjectsApi();

    
    /**
     * Adds a tag to the project
     *
     * Creates a new tag and attach it to the project. If the tag already exist, the existing tag will be attached to the project.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void addTagToProjectTest() throws ApiException {
        String projectUid = null;
        TagsPostRequest newtag = null;
        String envelope = null;
        List<String> embed = null;
        String i4lProcessUid = null;
        ProjectsEndpointType response = api.addTagToProject(projectUid, newtag, envelope, embed, i4lProcessUid);

        // TODO: test validations
    }
    
    /**
     * Deletes a single e project by its UID
     *
     * A single project is deleted. This endpoint deletes the project itself and the connected to subordered data like SpatialSources, etc. The subordered data itself are not deleted
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void delProjectByUIDTest() throws ApiException {
        String projectUid = null;
        String envelope = null;
        List<String> embed = null;
        String i4lProcessUid = null;
        ProjectsEndpointType response = api.delProjectByUID(projectUid, envelope, embed, i4lProcessUid);

        // TODO: test validations
    }
    
    /**
     * Removes a model from a project.
     *
     * Removes a model from a project. By default only the link between model and project is removed.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void detachProjectModelTest() throws ApiException {
        String projectUid = null;
        String modelUid = null;
        String envelope = null;
        String forceDelete = null;
        ProjectsEndpointType response = api.detachProjectModel(projectUid, modelUid, envelope, forceDelete);

        // TODO: test validations
    }
    
    /**
     * Removes a spatialsource from a project.
     *
     * Removes a spatial from a project. By default only the link between spatialsource and project is removed.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void detachProjectSpatialSourceTest() throws ApiException {
        String projectUid = null;
        String spatialsourceUid = null;
        String forceDelete = null;
        ProjectsEndpointType response = api.detachProjectSpatialSource(projectUid, spatialsourceUid, forceDelete);

        // TODO: test validations
    }
    
    /**
     * Removes a tag from a project.
     *
     * Removes a tag from a project. By default only the link between tag and project is removed.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void detachProjectTagTest() throws ApiException {
        String projectUid = null;
        String tag = null;
        String envelope = null;
        String forceDelete = null;
        ProjectsEndpointType response = api.detachProjectTag(projectUid, tag, envelope, forceDelete);

        // TODO: test validations
    }
    
    /**
     * Returns an array of connect objects
     *
     * Returns an array of connect objects of a project. For each connected object the endpoint returns the type, name and uuid
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getConnectedObjectsByProjectUIDTest() throws ApiException {
        String projectUid = null;
        String envelope = null;
        Integer page = null;
        String sort = null;
        List<String> fields = null;
        List<String> embed = null;
        ConnectedObjectsEndpointType response = api.getConnectedObjectsByProjectUID(projectUid, envelope, page, sort, fields, embed);

        // TODO: test validations
    }
    
    /**
     * Returns the models of a project
     *
     * Returns the models of a project
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getModelsByProjectUIDTest() throws ApiException {
        String projectUid = null;
        String envelope = null;
        Integer page = null;
        String sort = null;
        List<String> fields = null;
        List<String> embed = null;
        List<ModelsEndpointType> response = api.getModelsByProjectUID(projectUid, envelope, page, sort, fields, embed);

        // TODO: test validations
    }
    
    /**
     * Returns the tags of a project.
     *
     * Is this method really necessary? Returns the tags of a project.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getProjectTagsByProjectUIDTest() throws ApiException {
        String projectUid = null;
        String envelope = null;
        TagsListResponse response = api.getProjectTagsByProjectUID(projectUid, envelope);

        // TODO: test validations
    }
    
    /**
     * Get a GeoJSON structure containing a list of Projects.
     *
     * Get a GeoJSON structure containing a list of Projects. A single project is modeled as a GeoJSON feature.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getProjectsTest() throws ApiException {
        String envelope = null;
        List<String> uid = null;
        List<String> name = null;
        String aoi = null;
        List<String> tags = null;
        Integer page = null;
        String sort = null;
        List<String> fields = null;
        List<String> embed = null;
        ProjectsEndpointType response = api.getProjects(envelope, uid, name, aoi, tags, page, sort, fields, embed);

        // TODO: test validations
    }
    
    /**
     * Getting single Projects by its UID
     *
     * Getting single Projects by its UID. The project is modeled as a feature in a GeoJSON structure.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getProjectsByUIDTest() throws ApiException {
        String projectUid = null;
        String envelope = null;
        List<String> embed = null;
        ProjectsEndpointType response = api.getProjectsByUID(projectUid, envelope, embed);

        // TODO: test validations
    }
    
    /**
     * Returns the SpatialSources of a Project.
     *
     * Returns the SpatialSources of a Project.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void getSpatialSourceByProjectUIDTest() throws ApiException {
        String projectUid = null;
        String envelope = null;
        Integer page = null;
        String sort = null;
        List<String> fields = null;
        List<String> embed = null;
        List<SpatialSourcesEndpointType> response = api.getSpatialSourceByProjectUID(projectUid, envelope, page, sort, fields, embed);

        // TODO: test validations
    }
    
    /**
     * Create a new model
     *
     * Create a new model.  To add a new Model , the content of Models  must be stored in advanced via the ContentItem endpoint
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void newModelUnderProjectTest() throws ApiException {
        String projectUid = null;
        ModelsPostRequest newmodel = null;
        String envelope = null;
        List<String> embed = null;
        String i4lProcessUid = null;
        ProjectsEndpointType response = api.newModelUnderProject(projectUid, newmodel, envelope, embed, i4lProcessUid);

        // TODO: test validations
    }
    
    /**
     * Create a new project
     *
     * Create a new project. The new project is modeled as a feature in a GeoJSON structure. Currently only one project feature is allowed.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void newProjectTest() throws ApiException {
        ProjectsPostRequest newproject = null;
        String envelope = null;
        List<String> embed = null;
        String i4lProcessUid = null;
        ProjectsEndpointType response = api.newProject(newproject, envelope, embed, i4lProcessUid);

        // TODO: test validations
    }
    
    /**
     * Create a new SpatialSource
     *
     * Create a new SpatialSource. To add a new SpatialSource , the content of SpatialSource  must be stored in advanced via the ContentItem endpoint
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void newSpatialSourceUnderProjectTest() throws ApiException {
        String projectUid = null;
        SpatialSourcesPostRequest newspatialsource = null;
        String envelope = null;
        List<String> embed = null;
        String i4lProcessUid = null;
        ProjectsEndpointType response = api.newSpatialSourceUnderProject(projectUid, newspatialsource, envelope, embed, i4lProcessUid);

        // TODO: test validations
    }
    
    /**
     * Update a project
     *
     * Updates some attributes of a project.
     *
     * @throws ApiException
     *          if the Api call fails
     */
    @Test
    public void updateProjectsTest() throws ApiException {
        String projectUid = null;
        RFC6902PatchRequest patchproject = null;
        String envelope = null;
        List<String> embed = null;
        String i4lProcessUid = null;
        ProjectsEndpointType response = api.updateProjects(projectUid, patchproject, envelope, embed, i4lProcessUid);

        // TODO: test validations
    }
    
}
